

read "CoreDefs.asm";read "BootStrap.asm"
limit &E00	
org &50


;
;Rastercolor buffer - 80 bytes (&50
RasterColors_ColorArray1:
	defb 1
	defb 1
	defb 64+20,64+24,64+29,64+11	 :IlluminatedPaletteA_Plus2
RasterColors_ColorArray2:
	defb 1
	defb 1

	defb 64+20,64+12,64+13,64+11	:IlluminatedPaletteB_Plus2
	defb 0
	defb 64+20,64+24,64+29,64+11
	defb 12
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+24,64+29,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
RasterColors_ColorArray3:
	defb 1
	defb 1
	defb 64+20,64+12,64+13,64+11 :IlluminatedPaletteC_Plus2
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
RasterColors_ColorArray4:
	defb 1
	defb 1 
	defb 64+20,64+31,64+14,64+11 :IlluminatedPaletteD_Plus2
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+31,64+14,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+31,64+14,64+11



align 256,&00
StarArraySize equ 255
StarArrayPointer: 	
defs StarArraySize*3,&00


ObjectArraySize equ 60
PlayerStarArraySize equ 36

align 256,&00
PlayerStarArrayPointer: 
defs 64,&00
ObjectArrayPointer:
defs 64,&00
align 256,&00
defs 255*5,&00

;defs ObjectArraySize*6,&00
;defs PlayerStarArraySize*3,&00

;align 256,&00

	

Event_SavedSettings:
defs 4*16,&00


RasterColors_ColorArray1Alt:
	defb 1
	defb 1
	defb &54,&54,&54,&54		 :IlluminatedPaletteAAlt_Plus2
RasterColors_ColorArray2Alt:
	defb 1
	defb 1
	defb &54,&54,&54,&54		 :IlluminatedPaletteBAlt_Plus2
RasterColors_ColorArray3Alt:
	defb 1
	defb 1
	defb &54,&54,&54,&54		 :IlluminatedPaletteCAlt_Plus2
RasterColors_ColorArray4Alt:
	defb 1
	defb 1 
	defb &54,&54,&54,&54		 :IlluminatedPaletteDAlt_Plus2



CustomRam:
defs 64 ;  Pos-Tick-Pos-Tick ; enough memory for 16 enemies!




;org &1000
;incbin "Sprites\PLAYER.SPR"
limit &3fff
org &1800
;incbin "Sprites\LEVEL1A2.SPR"
incbin "Sprites\LEVEL4.SPR"






org &3800







evtSettingsBank_Save equ %10010000+15
evtSettingsBank_Load equ %10010000+0
evtMultipleCommands equ %01110000

evtAddToForeground equ 135
evtAddToBackground equ 134
evtJumpToNewTime   equ 136
evtCallAddress	   equ 137
evtSetMoveLife     equ 128
evtSetProg	   equ 129
evtSetLife	   equ 130
evtSetMove	   equ 131
evtSetProgMoveLife equ 132
evtSetSprite	   equ 133

evtReprogramCustomMove1 equ %11110100
evtReprogramCustomMove2 equ %11110101
evtReprogram_PowerupSprites equ %11110110

evtSingleSprite equ 0

prgSpecial	equ 2
prgBonus 	equ 3
prgMovePlayer	equ 4
prgFireSnail	equ %10000000
prgFireSlow	equ %01100000
prgFireMid	equ %01000000
prgFireMid2	equ %11000000
prgFireFast	equ %00100000


mveStatic 	equ &24
mveSeaker	equ %10000100
mveWave		equ %10100000
mveWaveSmall	equ %10010000
mveCustom1	equ %11110000

lifEnemy	equ %11000000	;HurtByBullets,Hurts Player
lifTimed	equ %00000000	;Doesnt hurt, dies automatically
lifDeadly	equ %01000000	;Deadly and cant be shot
TwoFrameSprite  equ 128

BossSpriteNum1 defb 0
BossSpriteNum2 defb 1
BossSpriteNum3 defb 2



;Event_SavedSettings
;defs 4*16,&00


EventStreamArray:

;defb 1,128,&24,128+64+60		; Move Static




defb 0,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54	

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*2+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54		



; Define the background


; Define the background
defb 0,240+3,%11111111,30,%00000010

defb 0,240+1,0,2*20+1				; (Time,Cmd,Off,Bytes) Load 41 bytes into the background - 41 bytes is the limit


defb &0F,&0F	;1; first line

defb 198,&0D	;2

defb 196,&07	;3
defb 190,&0A	;4
defb 186,&05	;5
defb 180,&08	;6
defb 170,&02	;7; line num, New byte
defb 160,&00	;8
defb 150,&00	;9
defb 120,&20	;10; line num, New byte
defb 110,&80	;11; line num, New byte
defb 108,&20	;12 line num, New byte
defb 90,&0	;13 line num, New byte
defb 80,&0	;14
defb 24,&20	;15
defb 20,&80	;16
defb 16,&A0	;17
defb 12,&02	;18
defb 8,&08	;19
defb 4,&0A	;20
defb 255



;We will use 4 Paralax layers
; ---------()- (sky)		%11001000
; ------------ (Far)		%11000100
; -----X---X-- (mid)		%11000010	Bank 1
; []=====[]=== (foreground) 	%11000001	Bank 0

defb 0,evtAddToBackground

defb 0,%11110010				;Install a custom hit handler
defw CustomObjectHitHandler


defb 0,evtReprogram_PowerupSprites,128+99,128+99,128+99,128+16	; Define powerup sprites

; Background L
defb 0,128+4,1,%11000001,0			; Program - Bitshift Sprite... Move - dir Left Slow ... Life - immortal
defb 0,evtSettingsBank_Save,0				; Save Object settings to Bank 0

defb 0,128+4,1,%11000010,0			; Program - Bitshift Sprite... Move - dir Left Slow ... Life - immortal
defb 0,evtSettingsBank_Save,1				; Save Object settings to Bank 1



; Lambtron
defb 0,evtMultipleCommands+3					; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,prgFireMid2+17,&61,lifEnemy+3	; Program - Fire Left... Move - wave 10101100 ... Hurt by bullets, hurts player, life 4
defb 	evtSetSprite,TwoFrameSprite+17		
defb 	evtSettingsBank_Save,2		

; Shoe!
defb 0,evtMultipleCommands+3			; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,0,&7C,%11000000+6	
defb 	evtSetSprite,TwoFrameSprite+18
defb 	evtSettingsBank_Save,3	

; CHU!
defb 0,evtMultipleCommands+3			; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,0,mveSeaker,lifEnemy+6	
defb 	evtSetSprite,TwoFrameSprite+19
defb 	evtSettingsBank_Save,4	

; CHU! Text 
defb 0,evtMultipleCommands+3			; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,0,mvestatic,lifTimed+3
defb 	evtSetSprite,TwoFrameSprite+20
defb 	evtSettingsBank_Save,5



; Custom move code
defb 0,evtReprogramCustomMove1
defw CustomMoveYoYo

; start of level
StartOfLevel:


;Palette Change
defb 1,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&44,&40	

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&44,&40		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40			












; Load Palette

	defb 2,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&5D,&52,&4B			

	;defb 0,240,6,6			; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 5
	;defb 1				
	;defb &54,&55,&43,&4B		

	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 32	;delay			
	defb &54,&5D,&52,&4B			

	defb 240,26*1+6,1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&5D,&52,&4B			
		
	


;defb 5,%01110000+2			; 3 commands at the same timepoint
;defb evtSetProgMoveLife,0,&24,10
;defb 	0,128+	0,140+24,170+24	; 	; Single Object sprite 11 (animated)



	;defb 1				
	;defb &54,&4C,&56,&4B

; hit target
defb 10,%01110000+3			; 2 commands at the same timepoint;
;21 is invisible sprite
defb 	128+4,prgSpecial,mveCustom1,%11000000+40	; Program - Starburst ... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4;
defb 	0,21,160+27+6,64+24+24-24	; 	; Single Object sprite 11 (animated)
defb 	138					; save Object pointer
defw 		BossTarget			; save Object pointer


; Fire target 2
;defb 10,%01110000+3			; 2 commands at the same timepoint;
;
;defb 	128+4,%10000000+15,mveCustom1,0	; Program - Starburst ... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4;
;defb 	0,21,160+27,64+24+48	; 	; Single Object sprite 11 (animated)
;defb 	138					; save Object pointer
;defw 		FireTarget2			; save Object pointer

; Fire target 3
;defb 10,%01110000+3			; 2 commands at the same timepoint;
;
;defb 	128+4,%01100000+7,mveCustom1,0	; Program - Starburst ... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4;
;defb 	0,21,160+27,64+24	; 	; Single Object sprite 11 (animated)
;defb 	138					; save Object pointer
;defw 		FireTarget3			; save Object pointer



;boss1
defb 10,%01110000+6			; 3 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+1				; Load Settings from bank 1
defb 	evtSetMove,mveCustom1
defb 	129,0				; Change to program Custom
defb 	0,128+	0,160+24,64+24-24	; 	; Single Object sprite 11 (animated)
defb 	138					; save Object pointer
defw 		BossObject1			; save Object pointer

;Boss2
defb 10+3,%01110000+6			; 3 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+1				; Load Settings from bank 1
defb 	129,0				; Change to program Custom
defb 	evtSetMove,mveCustom1
defb 	0,128+	1,160+24,64+24-24	; 	; Single Object sprite 11 (animated)
defb 	138					; save Object pointer
defw 		BossObject2			; save Object pointer


; Fire target 1
defb 10+3,%01110000+3			; 2 commands at the same timepoint;
;
defb 	128+4,%01100000+13,mveCustom1,0	; Program - Starburst ... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4;
defb 	0,21,160+27,64+24-24	; 	; Single Object sprite 11 (animated)
defb 	138					; save Object pointer
defw 		FireTarget1			; save Object pointer


;Boss3
defb 10+6,%01110000+6			; 3 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+1				; Load Settings from bank 1
defb 	129,0				; Change to program Custom
defb 	evtSetMove,mveCustom1
defb 	0,128+	2,160+24,64+24-24	; 	; Single Object sprite 11 (animated)
defb 	138					; save Object pointer
defw 		BossObject3			; save Object pointer

;akanbee
defb 26,%01110000+2			; 3 commands at the same timepoint
defb evtSetProgMoveLife,0,&24,3
defb 	0,128+	15,120+24,170+24	; 	; Single Object sprite 11 (animated)




;defb 70,%10001001			;Call a memory location
;defw	StopBossMovement
;defb 20+18+24	
;defb 136				; Jump to a different level point
;defw StartOfLevel			; pointer
;defb 255					; new time
AttackLoop:



defb 30,evtMultipleCommands+2					; 3 commands at the same timepoint
defb evtSettingsBank_Load+2
defb 	evtSingleSprite+ 12

defb 32,evtMultipleCommands+2					; 3 commands at the same timepoint
defb evtSettingsBank_Load+2
defb 	evtSingleSprite+ 12

defb 34,evtMultipleCommands+2					; 3 commands at the same timepoint
defb evtSettingsBank_Load+2
defb 	evtSingleSprite+ 12

defb 36,evtMultipleCommands+2					; 3 commands at the same timepoint
defb evtSettingsBank_Load+2
defb 	evtSingleSprite+ 12

defb 36,evtMultipleCommands+8					; 3 commands at the same timepoint
defb evtSettingsBank_Load+3
defb 	0, 18,12*1+24,24	; 	; Single Object / 
defb 	0, 18,12*3+24,24	; 	; Single Object / 
defb 	0, 18,12*5+24,24	; 	; Single Object / 
defb 	0, 18,12*7+24,24	; 	; Single Object / 
defb 	0, 18,12*9+24,24	; 	; Single Object / 
defb 	0, 18,12*11+24,24	; 	; Single Object / 
defb 	0, 18,12*13+24,24	; 	; Single Object / 




defb 50,evtMultipleCommands+2					; 3 commands at the same timepoint
defb evtSettingsBank_Load+2
defb 	evtSingleSprite+ 12

defb 52,evtMultipleCommands+2					; 3 commands at the same timepoint
defb evtSettingsBank_Load+2
defb 	evtSingleSprite+ 12

defb 54,evtMultipleCommands+2					; 3 commands at the same timepoint
defb evtSettingsBank_Load+2
defb 	evtSingleSprite+ 12

defb 56,evtMultipleCommands+2					; 3 commands at the same timepoint
defb evtSettingsBank_Load+2
defb 	evtSingleSprite+ 12

defb 56,evtMultipleCommands+8					; 3 commands at the same timepoint
defb evtSettingsBank_Load+3
defb 	0, 18,12*0+24,24	; 	; Single Object / 
defb 	0, 18,12*2+24,24	; 	; Single Object / 
defb 	0, 18,12*4+24,24	; 	; Single Object / 
defb 	0, 18,12*6+24,24	; 	; Single Object / 
defb 	0, 18,12*8+24,24	; 	; Single Object / 
defb 	0, 18,12*10+24,24	; 	; Single Object / 
defb 	0, 18,12*12+24,24	; 	; Single Object / 





defb 80	
defb 	evtJumpToNewTime			; Jump to a different level point
defw 	AttackLoop				; pointer
defb	 20					; new time

ChuAttack:
defb 25,evtAddToForeground

defb 25,evtMultipleCommands+2					; 3 commands at the same timepoint
defb 	evtSettingsBank_Load+4
defb 	0
defb 		128+19	;sprite (Chu Seaker)
defb		140+24	:ChuXa_Plus1
defb 		170+24	:ChuYa_Plus1
	
defb 25,evtMultipleCommands+2					; 3 commands at the same timepoint
defb 	evtSettingsBank_Load+5
defb 	0
defb 		128+20	;sprite (Chu text)
defb		140+24	:ChuXb_Plus1
defb 		170+24	:ChuYb_Plus1

defb 25,evtAddToBackground	

defb 25	
defb 	136					; Jump to a different level point
defw 	AttackLoop	:EndChuPointer_Plus2	; pointer
defb	 20		:EndChuTime_Plus1	; new time




LevelEndAnim:
defb 253,%01110000+2			; 3 commands at the same timepoint
defb evtSetProgMoveLife,prgMovePlayer,&24,10
defb 	0,128+	21,140+24,100+24	; 	; Single Object sprite 11 (animated)

;Palette Change
defb 254,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&44,&40	

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&44,&40		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40			




defb 255,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54	

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*2+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

defb 0,evtCallAddress			;Call a memory location
defw	EndLevel


EndLevel:
	pop hl	;
	ld hl,	&0105
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return



LevelInit:

	; wipe our memory, to clear out any junk from old levels
;	ld de,&51
;	ld hl,&50
;	ld bc,&5FF
;	ld (hl),0
;	ldir 


	ld a, StarArraySize
	ld hl,StarArrayPointer
	call AkuYou_StarArrayInit_Enemy 

	ld a, PlayerStarArraySize
	ld hl,PlayerStarArrayPointer
	call AkuYou_StarArrayInit_Player 

	ld a,ObjectArraySize
	ld hl,ObjectArrayPointer
	call AkuYou_ObjectArray_Init



	ld a,1
	ld bc,RasterColors_ColorArray1
	ld de,RasterColors_ColorArray2
	ld hl,RasterColors_ColorArray3
	ld ix,RasterColors_ColorArray4
	ld iy,null
	call Akuyou_RasterColors_SetPointers




	ld hl,EventStreamArray		;Event Stream
	ld de,Event_SavedSettings	;Saved Settings
	call AkuYou_Event_StreamInit

	ld hl,&1800		
	ld de,&1000
	call AkuYou_SpritePointerInit

	call Akuyou_Music_Restart

	call Akuyou_ScreenBuffer_Init
	call Akuyou_RasterColors_Init

	;call RasterColors_Reset
LevelLoop:

	;ld a,128+0
	;ld hl,(BossObject1)
	;call SetSprite

	call Akuyou_Background_Clear
	;ld l,&08
	;call Timer_Stop
	;ld l,&09
	;call Timer_Stop
	;ld a,"B"
	;call &bb5a 


	call Akuyou_EventStream_Process
	;ld l,&0a
	;call Timer_Stop
	;ld a,"S"
	;call &bb5a 


	call Akuyou_ObjectArray_Redraw
	;ld l,&0b
	;call Timer_Stop
	;ld a,"O"
	;call &bb5a 

	ld a,(BossHurt)
	cp 0
	jp z,DontReset
	dec a
	ld (BossHurt),a

	jp nz,DontReset
	
	;reset the sprites to the non hurt state
	ld a,(BossSpriteNum1)
	add 128
	ld hl,(BossObject1)
	call SetSprite

	ld a,(BossSpriteNum2)
	add 128
	ld hl,(BossObject2)
	call SetSprite

	ld a,(BossSpriteNum3)
	add 128
	ld hl,(BossObject3)
	call SetSprite



DontReset:
	call Akuyou_Player_Handler
	;ld l,&0c
	;call Timer_Stop
	;ld a,"P"
	;call &bb5a 



	call Akuyou_StarArray_Redraw
	;ld l,&0d
	;call Timer_Stop
	;ld a,"S"
	;call &bb5a 


	call AkuYou_Player_StarArray_Redraw
	;ld l,&0e
	;call Timer_Stop
	;ld a,"F"
	;call &bb5a 


	call AkuYou_Player_DrawUI

	call Akuyou_PlaySfx


	;ld a,"U"
	;call &bb5a 

	call ShowBossText

	ifdef debug
		call ShowLevelTime
	endif
	;ld a,0
	;call Akuyou_ShowCompiledSprite
	call Akuyou_ScreenBuffer_Flip
	jp LevelLoop

LevelShutdown:

ret


ShowLevelTime:
	;ld hl,&C000
	;call Akuyou_ShowSprite_SetBankAddr
	call Akuyou_SpriteBank_Font

	ld hl,&1001
	call Akuyou_DrawText_LocateSprite

	call Akuyou_GetLevelTime
	push bc	
	call ShowHex
	pop bc
	ld a,b
	call ShowHex
ret


ShowHex:

	push af         ;store original byte value
	rrca            
	rrca
	rrca
	rrca
	call ShowHexDigit
	pop af          ;retrieve original byte value

ShowHexDigit:
;	and %00001111   ;isolate lower nibble. (This contains the digit value 0...15)
;	add a,"0"       ;add ASCII for 0. Digits 0...9 become "0"..."9", digits 10..15
;	cp "9"+1        
;	jr c,ShowHexDigitNum     ;if number is in digit range 0...9, display digit
;	add a,"A"-"9"-1 ;modify ASCII value so that digits in the range 10...15
and %00001111   ;isolate lower nibble. (This contains the digit value 0...15)
cp &a           ;Less than 10?  Set carry if so
sbc a,&69
daa             ;Because previous instruction was a subtract operation this
                ;is known as 'das' in x86
ShowHexDigitNum:
	jp Akuyou_DrawText_CharSprite   ;display digit

BossObject1: defw &6969
BossObject2: defw &6969
BossObject3: defw &6969
;HandObject1 defw &6969
;HandObject2 defw &6969
;HandObject3 defw &6969
;HandObject4 defw &6969
;HandObject5 defw &6969
;HandObject6 defw &6969
BossTarget: defw &6969
BossLife: defb 150
BossHurt: defb &0
FireTarget1: defw &6969
FireTarget2: defw &6969
FireTarget3: defw &6969
SetSprite:; YYYYYXXXXMMMMSSSLLLLPPP
	ld i,a
	ld a,h
	cp &69
	ret z		;not on screen yet


;	ld d,0
;	ld e,objectarraysize
	;y
	inc h;add hl,de 	
	;x
	inc h;	add hl,de 	
	;move
	inc h;	add hl,de 	
	ld a,i
	ld (hl),a
	inc h;	add hl,de 	;spr
	inc h;	add hl,de 	;Life

	;program
ret

SetProgram:; YYYYYXXXXMMMMSSSLLLLPPP
	ld i,a
	ld a,h
	cp &69
	ret z		;not on screen yet


	ld d,0
	ld e,objectarraysize
	;y
	inc h;	add hl,de 	
	;x
	inc h;	add hl,de 	
	;move
	inc h;	add hl,de 	

	inc h;	add hl,de 	;spr
	inc h;	add hl,de 	;Life
	ld a,i
	ld (hl),a
	;program
ret
CustomObjectHitHandler:

ld a,iyl
cp prgSpecial
jp nz,Akuyou_Object_DecreaseLifeShot	; if this object isn't the boss target, just run the normal routine
	;iyl ; Program Code
	;ixl ;Life
	;iyh  ;spr
	;ixh ;Move
	;b ;X
	;c ;Y
ld ixl,%11000000+40	; Make object immortal
push de
push hl
	ld a,(BossSpriteNum1)
	add 128+3
	ld hl,(BossObject1)
	call SetSprite

	ld a,(BossSpriteNum2)
	add 128+3
	ld hl,(BossObject2)
	call SetSprite

	ld a,(BossSpriteNum3)
	add 128+3
	ld hl,(BossObject3)
	call SetSprite

	ld a,r
	srl a
	srl a
	add 120
	ld hl,(FireTarget1)
	call ChangeY

	ld a,r
	srl a
	srl a
	add 120
	ld hl,(FireTarget2)
	call ChangeY

	ld a,r
	srl a
	srl a
	add 120
	ld hl,(FireTarget3)
	call ChangeY



	ld a,2
	ld (BossHurt),a

	ld a,(BossLife)
	dec a
	;cp 80
	;jp z,BossLife1
	;cp 60
	;jp z,BossLife2
	cp 75
	jp z,BossLife3
	;cp 20
	;jp z,BossLife4
	cp 1
	jp z,BossLife5		;5 means boss is dead
	jp UpdateBossLife
BossLife5:
	push af

		; boss is dead

		ld ixl,0	; Make object immortal

		ld a,0
		ld (BossHurt),a

		ld a,0
		ld hl,(FireTarget1)
		call SetProgram
		ld a,0
		ld hl,(FireTarget2)
		call SetProgram
		ld a,0
		ld hl,(FireTarget3)
		call SetProgram

		


		ld a,12
		ld hl,(BossObject1)
		call SetSprite
		ld a,128+13
		ld hl,(BossObject2)
		call SetSprite
		ld a,128+14
		ld hl,(BossObject3)
		call SetSprite	
		ld a,2
		call Akuyou_DoSmartBombCall

		ld hl,LevelEndAnim
		ld a,249
		call Akuyou_SetLevelTime


	pop af
	jp UpdateBossLife
BossLife4:
push af
	;	ld a,128+10
	;	ld hl,(BossObject2)
	;	call SetSprite
	;	ld a,128+11
	;	ld hl,(BossObject3)
	;	call SetSprite	
	pop af
	jp UpdateBossLife
BossLife3:
	push af
		;ld a,128+8
		;ld hl,(BossObject2)
		;call SetSprite
		;ld a,128+9
		;ld hl,(BossObject3)
		;call SetSprite	

		ld a,0+6
		ld (BossSpriteNum1),a
		ld a,1+6
		ld (BossSpriteNum2),a
		ld a,2+6
		ld (BossSpriteNum3),a

	pop af
	jp UpdateBossLife
BossLife2:
	push af
	;	ld a,128+6
	;	ld hl,(BossObject2)
	;	call SetSprite
	;	ld a,128+7
	;	ld hl,(BossObject3)
	;	call SetSprite	
	pop af
	jp UpdateBossLife
BossLife1:
	push af
	;	ld a,128+4
	;	ld hl,(BossObject2)
	;	call SetSprite
	;	ld a,128+5
	;	ld hl,(BossObject3)
	;	call SetSprite	
	pop af
	jp UpdateBossLife
UpdateBossLife:
	ld (BossLife),a
	pop hl
	pop de
ret

ChangeY:
	ld i,a
	ld a,h
	cp &69
	ret z		;not on screen yet

	ld a,i
	ld (hl),a
ret

;jp Akuyou_Object_DecreaseLifeShot
ShowBossText2:


	or a
	ret z

	ld a,(BossCharNum_Plus1-1)
	inc a
	ld (BossCharNum_Plus1-1),a

	ld bc,BossText2
	jp ShowBossText_StartText


ShowBossText:
	ld a,15 :OnscreenTimer_Plus1
	cp 10
	jp C,ShowBossText2
	ld bc,BossText
ShowBossText_StartText:
	;ld hl,&C000
	;call Akuyou_ShowSprite_SetBankAddr
	call Akuyou_SpriteBank_Font
	ld l,4
	ld a,1:BossCharNum_Plus1
	ld i,a	; show up to 255 chars
	
ShowBossText_MoreText:
	ld a,(bc)

	or a
	jp z,ShowBossText_AllOnscreen ; See if we have reached the end of the string

	ld h,a
	inc bc

	push hl
		call Akuyou_DrawText_LocateSprite

		call Akuyou_DrawText_PrintString
	pop hl
	inc l
	inc l
	inc l
	ld a,i
	dec a
	inc bc
	jp nz,ShowBossText_MoreText

	ld a,(bc)
	or a
	jp z,ShowBossText_AllOnscreen ; See if we have reached the end of the string
	ld a,(BossCharNum_Plus1-1)
	inc a
	cp 20
	jp c,ShowBossTextNoSpeedup
	inc a
ShowBossTextNoSpeedup:
	ld (BossCharNum_Plus1-1),a

ret
ShowBossText_AllOnscreen:
	ld a,(OnscreenTimer_Plus1-1)
	dec a
	ld (OnscreenTimer_Plus1-1),a

	cp 10
	ret nz
	ld a,9
	ld (OnscreenTimer_Plus1-1),a
;	ld a,BossText2End-BossText2-20
	ld a,1
	ld (BossCharNum_Plus1-1),a
ret

BossText: 
db  11,"W A R N I N G ! ! ","!"+&80
db  06,"A Big Copyright-Infringemen","t"+&80
db  07,"Is approaching: ZombiChu!!","!"+&80
db  05,""," "+&80
db  05,""," "+&80
db  07,"(Don't sue - I have no money!",")"+&80
;b  "12345678901234567890123456789","0"+&80
db &0



BossText2: 
db  05,""," "+&80
db  05,""," "+&80
db  05,""," "+&80
db  03,"And anyway, Satire is protecte","d"+&80
db  06,"according to the TPP an","d"+&80
db  07,"Freedom of speech law","s"+&80
db  15,"So bite me!","!"+&80
;we are using a speedup, so must be divisible by 3
BossText2End:db &0,&0,&0



;CustomRam:
;defs 8 ;
CustomMoveYoYo:		; B=X C=Y D=Move


	;dont mess with moves if the boss is dead
	ld a,(BossLife)
	cp 1
	ret z

	push de
		
	push ix

		ld ix,CustomRam
	

		call Akuyou_Timer_GetTimer
		ld d,a
		ld a,i	; Level time
		ld e,a


		ld a,(ix+0)

		bit 2,d				; tick
		jr z,CustomMoveYoYo_NoTick	


		;dont update more than once per tick!
		ld a,(ix+1)
		cp e
		jr z,CustomMoveYoYo_NoTick	
		ld a,e
		ld (ix+1),e

		ld a,(ix+0)


		inc a
		ld (ix+0),a	
CustomMoveYoYo_NoTick:
		ld a,(ix+0)
		cp 12
		jp nc,CustomMoveYoYo_AttackRetreat
		dec b
		jp CustomMoveYoYo_Done

CustomMoveYoYo_AttackRetreat		
		cp 32
		jp C,CustomMoveYoYo_NoAttack

		cp 32+16
		jp nC,CustomMoveYoYo_NoAttack

		cp 32+8
		jp nC,CustomMoveYoYo_Retreat
		dec b		
		dec b
		dec b		
		dec b
		jp CustomMoveYoYo_NoAttack
CustomMoveYoYo_Retreat
		inc b
		inc b
		inc b
		inc b
CustomMoveYoYo_NoAttack
		cp 32+16
		jp nz,CustomMoveYoYo_Vert

		push hl
			push bc
				call Akuyou_GetLevelTime
			pop bc
			ld (EndChuPointer_Plus2-2),hl
			ld (EndChuTime_Plus1-1),a
			ld a,b
			ld (ChuXa_Plus1-1),a
			ld (ChuXb_Plus1-1),a
	
			ld a,c
			ld (ChuYa_Plus1-1),a
			ld (ChuYb_Plus1-1),a

	
			ld hl,ChuAttack
			ld a,24
			call Akuyou_SetLevelTime
		pop hl
		ld a,12
		ld (ix+0),a
CustomMoveYoYo_Vert
		

		bit 4,e
		jr z,CustomMoveYoYo_up
		dec c
		dec c
		dec c
		dec c
		dec c
		dec c
		jp CustomMoveYoYo_Done
		;jr z,CustomMoveYoYo_DoJump
		;xor %00001111
		;jr CustomMoveYoYo_DoJump
CustomMoveYoYo_up
		inc c
		inc c
		inc c
		inc c
		inc c
		inc c
		jp CustomMoveYoYo_Done

CustomMoveYoYo_Done:
	pop ix
CustomMoveYoYo_Done2:
	pop de
ret
CustomMoveYoYo_Init:
	ld a,0
	ld (ix+0),a
	dec b
ret





null:ret

limit &3fff
org &3ff0
jp LevelInit; - Level Start &3ff0
jp LevelLoop; - Level loop &3ff3
jp null     ; - Level resume &3ff6
jp null     ; - Level Shutdown &3ff9





save direct "T24-SC1.D01",&1800,&2800	;address,size...}[,exec_address]


