limit &FFFF
read "CoreDefs.asm" ; Remember! Put this first!
read "EventStreamDefinitions.asm"
limit &E00	
org &50


DiskMap_Intro_Screens  		equ &13C1+&2800	; T19-SC1.D03
DiskMap_Intro_Screens_Size	equ 32	
DiskMap_Intro_Screens2  	equ &17C1+&2800	; T23-SC1.D03
DiskMap_Intro_Screens2_Size	equ 32	
DiskMap_Intro_Disk 		equ 2

;
;Rastercolor buffer - 80 bytes (&50
RasterColors_ColorArray1:
	defb 1
	defb 1
	defb 64+20,64+24,64+29,64+11	 :IlluminatedPaletteA_Plus2
RasterColors_ColorArray2:
	defb 1
	defb 1

	defb 64+20,64+12,64+13,64+11	:IlluminatedPaletteB_Plus2
	defb 0
	defb 64+20,64+24,64+29,64+11
	defb 12
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+24,64+29,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
RasterColors_ColorArray3:
	defb 1
	defb 1
	defb 64+20,64+12,64+13,64+11 :IlluminatedPaletteC_Plus2
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
RasterColors_ColorArray4:
	defb 1
	defb 1 
	defb 64+20,64+31,64+14,64+11 :IlluminatedPaletteD_Plus2
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+31,64+14,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+31,64+14,64+11



align 256,&00
StarArraySize equ 255
StarArrayPointer: 	
defs StarArraySize*3,&00


ObjectArraySize equ 60
PlayerStarArraySize equ 36

align 256,&00
PlayerStarArrayPointer: 
defs 64,&00
ObjectArrayPointer:
defs 64,&00
align 256,&00
defs 255*5,&00

;defs ObjectArraySize*6,&00
;defs PlayerStarArraySize*3,&00

;align 256,&00

	

Event_SavedSettings:
defs 4*16,&00



CustomRam:
defs 64 ;  Pos-Tick-Pos-Tick ; enough memory for 16 enemies!



limit &3FF0
org &2500
incbin "Sprites\Attack1.spr"
;incbin "Sprites\LEVEL1A.SPR"
org &3000
align 256,&00
RasterColors_ColorArray1Alt:
	defb 1
	defb 1				
	defb &54,&55,&4C,&4B	


RasterColors_ColorArray2Alt:
	defb 2	; Switches
	defb 32	;delay			
	defb &54,&58,&5C,&4B	
	defb 64+16-32;delay			
	defb &54,&5D,&53,&4B



RasterColors_ColorArray3Alt:
	defb 2
	defb 48
	defb &54,&46,&5B,&4B
	defb 128
	defb &54,&46,&5a,&4B



RasterColors_ColorArray4Alt:
	defb 3 ; no of switches
	defb 0	;delays			
	defb &54,&46,&5A,&4B
	defb 255	;delays			
	defb &54,&4C,&4D,&4B
	defb 36	;delays			
	defb &54,&46,&5A,&4B



EventStreamArray:



defb 0,128+4,0,&24,0				; Static object
defb 0,%10010000+15,2				; Save Object settings to Bank 2

defb 0,128+4,0,&60,0	
defb 0,%10010000+15,3

defb 0,128+4,0,&32,0			;2b 32 39
defb 0,%10010000+15,4



defb 0,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54	

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*2+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

defb 0,evtMultipleCommands+5
defb evtAddToForeground
defb 	evtSettingsBank_Load+2
defb 	evtSingleSprite,TwoFrameSprite+3 ,24+80-16	,24+80+6
defb 	evtSaveLstObjToAdd
defw 		charnikohime
defb evtAddToBackground

;defb 0,evtMultipleCommands+3
;defb 	evtSettingsBank_Load+2
;defb 	evtSingleSprite,TwoFrameSprite+5 ,24+160-16	,24+104
;defb 	evtSaveLstObjToAdd
;defw 		charNecromancer
;

;defb 0,evtMultipleCommands+3
;defb 	evtSettingsBank_Load+2
;defb 	evtSingleSprite,TwoFrameSprite+2 ,24		,24+160
;defb 	evtSaveLstObjToAdd
;defw 		charChibiko

;Palette Change
defb 2,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&44,&40	

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&44,&40		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40			




; Load Palette

	defb 4,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&4D,&4F,&4B;defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 255		;delay			
	defb &54,&47,&52,&4B	;	defb &54,&4D,&4F,&4B

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 0
	defb &54,&47,&52,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&47,&52,&4B	
	
	;defb 4	
	;defb 136				; Jump to a different level point
	;defw TestPos				; pointer
	;defb 115

defb 10,evtCallAddress			;Call a memory location
defw	ShowText1Init



defb 49,evtCallAddress			;Call a memory location
defw	ShowText0Init


	defb 50,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0		;delay			
	defb  &54,&58,&5F,&4B

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 20
	defb &54,&47,&52,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&47,&52,&4B	
	

defb 50,evtMultipleCommands+4
defb 	evtSettingsBank_Load+3
defb 	evtSingleSprite,TwoFrameSprite+0 ,24+160-24	,24+40-10
defb 	evtSingleSprite,TwoFrameSprite+1 ,24+160-12	,24+40-10
defb 	evtSingleSprite,TwoFrameSprite+2 ,24+160	,24+40-10

defb 51,evtSingleSprite,TwoFrameSprite+6 ,24+160-12-6	,24+40-10
defb 51,evtSingleSprite,TwoFrameSprite+6 ,24+160-12-6	,24+40+24+8-10
defb 51,evtSingleSprite,TwoFrameSprite+6 ,24+160-12	,24+40-10
defb 51,evtSingleSprite,TwoFrameSprite+6 ,24+160-12	,24+40+24+8-10

defb 51,evtSingleSprite,TwoFrameSprite+6 ,24+160-12	,24+40-10+8

;defb 51,evtSingleSprite,TwoFrameSprite+5 ,24+160-12	,24+40-10+20
;defb 21,evtSingleSprite,TwoFrameSprite+6 ,24+160-12-6	,24+40+24+24
;defb 52,evtCallAddress			;Call a memory location
;defw	halttest

	defb 52,%01110000+4			; 4 Commands

	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B

	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0		;delay			
	defb &54,&58,&5F,&4B;&54,&4D,&4F,&4B

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&4C,&52,&41	
	
	defb 240,26*2+6,5*2+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 2 ; no of switches
	defb 0	;delays			
	defb &54,&4C,&52,&41	
	defb 100	;delays			
	defb &54,&5C,&4C,&4D







defb 52,evtMultipleCommands+7
defb 	evtSettingsBank_Load+4
defb 	evtAddToBackground
defb 	evtSingleSprite,TwoFrameSprite+6  ,24+80-16	,24+80-4+10
defb 	evtSingleSprite,TwoFrameSprite+6  ,24+80-16+8	,24+80+10
defb 	evtAddToForeground
defb 	evtSingleSprite,TwoFrameSprite+5  ,24+80-16	,24+80+10
defb 	evtSaveLstObjToAdd
defw 		charnikohimehead




defb 52,evtCallAddress			;Call a memory location
defw	Decapitate




defb 54,evtCallAddress			;Call a memory location
defw	Decapitateend

defb 55,evtCallAddress			;Call a memory location
defw	DoClear4000

defb 68,evtCallAddress			;Call a memory location
defw	ShowText2Init




	defb 85	
	defb 136				; Jump to a different level point
	defw StartIntroProper				; pointer
	defb 67

StartIntroProper:
defb 68,evtCallAddress			;Call a memory location
defw	ShowText0Init

defb 68,evtCallAddress			;Call a memory location
defw ClearObjects


z; Load Palette

	defb 70,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&5D,&40,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0	;delay			
	defb &54,&5D,&40,&4B

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&5D,&40,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&5D,&40,&4B
	
defb 72,evtCallAddress			;Call a memory location
defw	ShowText3Init


defb 85,evtCallAddress			;Call a memory location
defw	ShowText4Init
;good

	defb 86,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&53,&5B,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0	;delay			
	defb &54,&53,&5B,&4B

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&53,&5B,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&53,&5B,&4B


defb 110,evtCallAddress			;Call a memory location
defw	ShowText5Init

;Bad

	defb 111,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&5C,&4C,&4D
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0	;delay			
	defb &54,&5C,&4C,&4D

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&5C,&4C,&4D

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&5C,&4C,&4D

defb 140,evtCallAddress			;Call a memory location
defw	ShowText6Init


;alternate

	defb 141,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5D,&4D
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0	;delay			
	defb &54,&58,&5D,&4D

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&58,&5D,&4D

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5D,&4D

	

;chibiko

	defb 170,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0	;delay			
	defb &54,&58,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&58,&5F,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B

defb 170,evtCallAddress			;Call a memory location
defw	ShowText7Init

	defb 175	
	defb 136				; Jump to a different level point
	defw SpeedUpB				; pointer
	defb 190
SpeedUpB:

;Fishing
defb 200,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&55,&5E,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 100	;delay			
	defb &54,&58,&5B,&4B

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&58,&5F,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B
defb 200,evtCallAddress			;Call a memory location
defw	ShowText8Init

	defb 205
	defb 136				; Jump to a different level point
	defw SpeedUpC				; pointer
	defb 220
SpeedUpC:

;Forest
	
defb 230,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&4C,&4A,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0	;delay			
	defb &54,&4C,&4A,&4B

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&58,&5F,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B


defb 230,evtCallAddress			;Call a memory location
defw	ShowText9Init

	defb 235
	defb 136				; Jump to a different level point
	defw SpeedUpD				; pointer
	defb 250
SpeedUpD:

;pollution
defb 5,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 10	;delay			
	defb &54,&52,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&58,&5F,&4B

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B
	
defb 5,evtCallAddress			;Call a memory location
defw	ShowText10Init

	defb 10
	defb 136				; Jump to a different level point
	defw SpeedUpE				; pointer
	defb 25
SpeedUpE:

;School

	defb 35,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0	;delay			
	defb &54,&58,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&58,&5F,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B


defb 35,evtCallAddress			;Call a memory location
defw	ShowText11Init

	defb 40
	defb 136				; Jump to a different level point
	defw SpeedUpF				; pointer
	defb 55
SpeedUpF:

defb 65,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 210	;delay			
	defb &54,&56,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&58,&5F,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B

defb 65,evtCallAddress			;Call a memory location
defw	ShowText12Init

	defb 70
	defb 136				; Jump to a different level point
	defw SpeedUpG				; pointer
	defb 85
SpeedUpG:

defb 95,evtCallAddress			;Call a memory location
defw	ShowText13Init

;Fire

	defb 100
	defb 136				; Jump to a different level point
	defw SpeedUpH				; pointer
	defb 115
SpeedUpH:
	
defb 125,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&4C,&4A,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0	;delay			
	defb &54,&4C,&4A,&4B

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&58,&5F,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B

TestPos:	
defb 125,evtCallAddress			;Call a memory location
defw	ShowText14Init

	defb 130
	defb 136				; Jump to a different level point
	defw SpeedUpI				; pointer
	defb 145
SpeedUpI:

;Lightning1

	defb 155,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*2+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 2	; Switches
	defb 255	;delay			
	defb &54,&58,&5F,&4B
	defb 30	;delay			
	defb &54,&56,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&58,&5F,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B


defb	155,evtCallAddress	;defb 155,evtCallAddress			;Call a memory location
defw	ShowText15Init

	defb 160
	defb 136				; Jump to a different level point
	defw SpeedUpJ				; pointer
	defb 175
SpeedUpJ:

;Lightning2

	defb 185,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&4A,&4B
	
	defb 240,26*0+6,5*2+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 2	; Switches
	defb 255	;delay			
	defb &54,&56,&4A,&4B
	defb 20	;delay			
	defb &54,&56,&4A,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&58,&5F,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B
defb 185,evtCallAddress			;Call a memory location
defw	ShowText16Init

	defb 190
	defb 136				; Jump to a different level point
	defw SpeedUpK				; pointer
	defb 205
SpeedUpK:

;heaven


	defb 215,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&5F,&5B,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0	;delay			
	defb &54,&5F,&5B,&4B

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&5F,&5B,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&5F,&5B,&4B
defb 215,evtCallAddress			;Call a memory location
defw	ShowText17Init

	defb 220
	defb 136				; Jump to a different level point
	defw SpeedUpL				; pointer
	defb 235
SpeedUpL:

;hell


	defb 245,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&5C,&4C,&4E
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0	;delay			
	defb &54,&5C,&4C,&4E

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&4C,&4E,&43	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&4C,&4E,&43

defb 245,evtCallAddress			;Call a memory location
defw	ShowText18Init
;chibiko

	defb 250
	defb 136				; Jump to a different level point
	defw SpeedUpN				; pointer
	defb 5
SpeedUpN:

	defb 20,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0	;delay			
	defb &54,&58,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&58,&5F,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B

defb 20,evtCallAddress			;Call a memory location
defw	ShowText19Init

;	defb 30
;	defb 136				; Jump to a different level point
;	defw SpeedUpM				; pointer
;	defb 45
;SpeedUpM

defb 50,evtCallAddress			;Call a memory location
defw	DoClear4000

;chibiko

	defb 50,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*2+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 2	; Switches
	defb 0	;delay			
	defb &54,&58,&4C,&4B	
	defb 106	;delay			
	defb &54,&58,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&58,&5F,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B
defb 50,evtCallAddress			;Call a memory location
defw	ShowText20Init

;	defb 60
;	defb 136				; Jump to a different level point
;	defw SpeedUpO				; pointer
;	defb 75
;SpeedUpO

TestHaunt:
;haunting
defb 90,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 95	;delay			
	defb &54,&4C,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&58,&5F,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B

defb 90,evtCallAddress			;Call a memory location
defw	ShowText21Init

;defb 110,evtCallAddress			;Call a memory location
;defw	ShowText22Init
defb 120, 136				; Jump to a different level point
defw 	FadeOut				; pointer
defb 	59





FadeOut:
defb 60,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&44,&40	

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&44,&40		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40			





defb 62,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54	

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*2+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54


defb 64,%10001001			;Call a memory location
	defw	EndLevel
EndLevel:
	pop hl	;
EndLevelFire:

	call DoClear4000

	ld hl,	&0100 				;load menu
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return

ResetEventStream:
	push hl
		; wipe our memory, to clear out any junk from old levels
		ld de,StarArrayPointer+1
		ld hl,StarArrayPointer
		ld bc,&5FF
		ld (hl),0
		ldir

	pop hl
	;ld hl,EventStreamFadeOut	;Event Stream
	ld de,Event_SavedSettings	;Saved Settings
	call AkuYou_Event_StreamInit
	

ret

DiskMap_EndOutro_Screens  	equ &0DC1	;13 T13-SC1.D03
DiskMap_EndOutro_Screens_Size	equ 24	; &2000
DiskMap_EndOutro_Disk 		equ 3

OutroScreen1 equ &4000
OutroScreen2 equ &4003
OutroScreen3 equ &4006
OutroScreen4 equ &4009

charChibiko: defw &6969
charnikohime: defw &6969
charnikohimeHead:defw &6969



LevelInit:

	;Load up the extra data - over the Bootstrap

	ld a,0
	ld hl,DiskMap_Intro_Screens 
	ld b,DiskMap_Intro_Screens_Size
	ld c,DiskMap_Intro_Disk
	ld de,&4000
	call Akuyou_LoadDiscSector
	di


;DiskMap_Intro       		equ &10C1	; T16-SC1.D03
;DiskMap_Intro_Size		equ 16
;DiskMap_Intro_128   		equ &12C1	; T18-SC1.D03
;DiskMap_Intro_128_Size	equ 8	
;DiskMap_Intro_Screens  	equ &13C1	; T19-SC1.D03
;DiskMap_Intro_Screens_Size	equ 24	
;DiskMap_Intro_Disk 		equ 3



	;call Keys_WaitForRelease


	ld hl,&2500		
	ld de,&1000
	call AkuYou_SpritePointerInit



;	call Akuyou_Music_Restart

;	call Akuyou_ScreenBuffer_Reset


	ld a,3
	call Akuyou_BankSwitch_128k_SetCurrent
	ld a,&40
	call Akuyou_ScreenBuffer_Alt


	; force the cpc to show c0000
	ld hl,&0000
	ld a,&C0
	call &bd1f;mc_screen_offset

	di

	call RasterColorsSetPalette1

	ld a,ObjectArraySize
	ld hl,ObjectArrayPointer
	call AkuYou_ObjectArray_Init


	ld hl,EventStreamArray		;Event Stream
	ld de,Event_SavedSettings	;Saved Settings
	call AkuYou_Event_StreamInit
	call AkuYou_RasterColors_StopMusic
	call Akuyou_RasterColors_Init
	
call	Clear4000;call ShowText2

;	call WaitForFire

LevelLoop:

	call null :ClearScreenPoint_Plus2 ;Clear4000


	call Akuyou_Timer_UpdateTimer
	halt
	call Akuyou_EventStream_Process
	halt
	call AkuYou_Player_ReadControls
		ld a, ixl	; read the keymap
		or %11110001
		cp 255
		jp nz,EndLevelFire
	halt
	call Akuyou_ObjectArray_Redraw

	call ShowBossText
	ld a,(BossCharNum_Plus1-1)
	ld b,a
	ld a,255
	sub b
	srl a
	srl a
	srl a
	srl a
	ld b,a
PauseLoopB:
	halt
	djnz PauseLoopB
;	call Akuyou_ScreenBuffer_Flip

	ld a,0 :ShowTextUpdate_Plus1
	or a
	jp z,LevelLoop
	cp 1
	jp z,ShowText1
	cp 2
	jp z,ShowText2
	cp 3
	jp z,ShowText3
	cp 4
	jp z,ShowText4
	cp 5
	jp z,ShowText5
	cp 6
	jp z,ShowText6
	cp 7
	jp z,ShowText7
	cp 8
	jp z,ShowText8
	cp 9
	jp z,ShowText9
	cp 10
	jp z,ShowText10
	cp 11
	jp z,ShowText11
	cp 12
	jp z,ShowText12
	cp 13
	jp z,ShowText13
	cp 14
	jp z,ShowText14
	cp 15
	jp z,ShowText15
	cp 16
	jp z,ShowText16
	cp 17
	jp z,ShowText17
	cp 18
	jp z,ShowText18
	cp 19
	jp z,ShowText19
	cp 20
	jp z,ShowText20
	cp 21
	jp z,ShowText21
	cp 22
	jp z,ShowText22
	cp 255
	jp z,ShowText0
	jp LevelLoop



Keys_WaitForRelease:
	call AkuYou_Player_ReadControls
	ld b,10
Keys_WaitForRelease_More:
	ld a,(hl)
	inc hl
	cp 255
	jp c,Keys_WaitForRelease
	djnz Keys_WaitForRelease_More
ret
WaitForFire:
	call PauseASec


WaitForFire_Continue:
	push bc
		call AkuYou_Player_ReadControls
	pop bc
	ld a, ixl	; read the keymap
	or %11110001
	cp 255
	jp z,WaitForFire_Continue
ret


PauseASec:
	push bc
	ld b,250
	ld c,4
PauseASecB:
		push bc
			call AkuYou_Player_ReadControls
		pop bc
		
	djnz PauseASecB
	dec c
	ld a,c
	or a
	jp nz,PauseASecB

	pop bc
ret


PauseASecForFire:
	push bc
	ld b,250
	ld c,4
PauseASecForFireB:
		push bc
			call AkuYou_Player_ReadControls
		pop bc
		ld a, ixl	; read the keymap
		or %11110001
		cp 255
		jp nz,PauseASecForFireDone
	djnz PauseASecForFireB
	dec c
	ld a,c
	or a
	jp nz,PauseASecForFireB

PauseASecForFireDone
	pop bc
ret


RasterColorsSetPalette1:
	ld a,1
	ld bc,RasterColors_ColorArray1
	ld de,RasterColors_ColorArray2
	ld hl,RasterColors_ColorArray3
	ld ix,RasterColors_ColorArray4
	ld iy,null;PaletteSwitcher
jp Akuyou_RasterColors_SetPointers

PaletteSwitcher:
	ld a,0:PaletteNo_Plus1
	cpl	
	ld (PaletteNo_Plus1-1),a
	or a
	jp nz,RasterColorsSetPalette1
RasterColorsSetPalette2:
	ld a,1
	ld bc,RasterColors_ColorArray1Alt
	ld de,RasterColors_ColorArray2Alt
	ld hl,RasterColors_ColorArray3Alt
	ld ix,RasterColors_ColorArray4Alt
	ld iy,PaletteSwitcher
jp Akuyou_RasterColors_SetPointers
Decapitateend:
		push hl
			ld a,&24
			ld hl,(charnikohimehead)
			call setmove
		pop hl
		ret
Decapitate:
		push hl
			ld a,4+128
			ld hl,(charnikohime)
			call setsprite
		pop hl
		ret

ClearObjects:
	push hl
		xor a
		ld hl,(charnikohime)
		ld (hl),a
		ld hl,(charnikohimehead)
		ld (hl),a
	pop hl
	ret
ShowText1Init:
		ld a,1
UpdateShowText:
		ld(ShowTextUpdate_Plus1-1),a
		ret
ShowText2Init:
		ld a,2
		jr UpdateShowText
ShowText3Init:
		ld a,3
		jr UpdateShowText
ShowText4Init:
		ld a,4
		jr UpdateShowText
ShowText5Init:
		ld a,5
		jr UpdateShowText
ShowText6Init:
		ld a,6
		jr UpdateShowText
ShowText7Init:
		ld a,7
		jr UpdateShowText
ShowText8Init:
		ld a,8
		jr UpdateShowText
ShowText9Init:
		ld a,9
		jr UpdateShowText
ShowText10Init:
		ld a,10
		jr UpdateShowText
ShowText11Init:
		ld a,11
		jr UpdateShowText
ShowText12Init:
		ld a,12
		jr UpdateShowText
ShowText13Init:
		ld a,13
		jr UpdateShowText
ShowText14Init:
		ld a,14
		jr UpdateShowText
ShowText15Init:
		ld a,15
		jr UpdateShowText
ShowText16Init:
		ld a,16
		jr UpdateShowText
ShowText17Init:
		ld a,17
		jr UpdateShowText
ShowText18Init:
		ld a,18
		jr UpdateShowText
ShowText19Init:
		ld a,19
		jr UpdateShowText
ShowText20Init:
		ld a,20
		jr UpdateShowText
ShowText21Init:
		ld a,21
		jr UpdateShowText
ShowText22Init:
		ld a,22
		jr UpdateShowText
ShowText0Init:
		ld a,255
		jr UpdateShowText
NoSpeech:
	ret

ShowText2:
		ld hl,Subtitles2
		ld a,23
		jp ResetText
ShowText3:


		ld hl,Subtitles3
		ld a,12
		jp ResetText
		

ShowText4:
		ld hl,Subtitles4

		ld a,12

		jp ResetText

ShowText5:
		ld hl,Subtitles5

		ld a,12

		jp ResetText

ShowText6:
		ld hl,Subtitles6

		ld a,12

		jp ResetText
ShowText7:

		ld hl,&4000+0 ;chibiko
		ld (CompiledSprite_Plus2-2),hl

		ld hl,Subtitles7

		ld a,18

		jp ResetText
ShowText8:
		ld hl,&4000+3 ;fishing
		ld (CompiledSprite_Plus2-2),hl
		ld hl,Subtitles8

		ld a,18

		jp ResetText
ShowText9:
		ld hl,&4000+6 ;camping
		ld (CompiledSprite_Plus2-2),hl
		ld hl,Subtitles9

		ld a,18

		jp ResetText
ShowText10:
		ld hl,&4000+9	;prank
		ld (CompiledSprite_Plus2-2),hl
		ld hl,Subtitles10
		ld a,18

		jp ResetText
ShowText11:
		ld hl,&4000+12 ;school1
		ld (CompiledSprite_Plus2-2),hl

		ld hl,Subtitles11
		ld a,18

		jp ResetText
ShowText12:
		ld hl,&4000+18 ;bulbs
		ld (CompiledSprite_Plus2-2),hl		

		ld hl,Subtitles12
		ld a,18
		jp ResetText
ShowText13:

		ld hl,&4000+21;plane
		ld (CompiledSprite_Plus2-2),hl
		ld hl,Subtitles13
		ld a,18
		jp ResetText
ShowText14:

		ld hl,&4000+12 ;school1
		ld (CompiledSprite_Plus2-2),hl
		ld hl,&4000+15 ;school2
		ld (CompiledSpriteB_Plus2-2),hl

		ld hl,Subtitles14
		ld a,18
		jp ResetText
ShowText15:
		call LoadScreens2

		ld hl,&4000 ; lightning1
		ld (CompiledSprite_Plus2-2),hl
		ld hl,null
		ld (CompiledSpriteB_Plus2-2),hl

		ld hl,Subtitles15
		ld a,18
		jp ResetText
ShowText16:
		ld hl,&4000 ; lightning1
		ld (CompiledSprite_Plus2-2),hl
		ld hl,&4000+3 ; lightning2
		ld (CompiledSpriteB_Plus2-2),hl

		ld hl,Subtitles16
		ld a,18
		jp ResetText
ShowText17:
		ld hl,&4000+9 ; Heaven
		ld (CompiledSprite_Plus2-2),hl
		ld hl,null ; 
		ld (CompiledSpriteB_Plus2-2),hl

		ld hl,Subtitles17
		ld a,18
		jp ResetText
ShowText18:

		ld hl,&4000+6 ; Hell
		ld (CompiledSprite_Plus2-2),hl

		ld hl,Subtitles18
		ld a,18
		jp ResetText
ShowText19:
		ld hl,&4000+12 ; photo2
		ld (CompiledSprite_Plus2-2),hl
		ld hl,&4000+15 ; photo1
		ld (CompiledSpriteB_Plus2-2),hl

		ld hl,Subtitles19
		ld a,16
		jp ResetText
ShowText20:

		ld hl,&4000+12 ; photo1
		ld (CompiledSpriteB_Plus2-2),hl

		ld hl,Subtitles20
		ld a,16
		jp ResetText
ShowText21:

		ld hl,&4000+18 ; Haunting
		ld (CompiledSpriteB_Plus2-2),hl

		ld hl,Subtitles21
		ld a,16
		jp ResetText
ShowText22:
		ld hl,Subtitles22
		ld a,16
		jp ResetText


LoadScreens2:
	call clear4000
	di
	call Akuyou_RasterColors_Disable
	;call Akuyou_Music_Stop

	call Akuyou_Firmware_Restore
	call Akuyou_ScreenBuffer_Reset	



	;Load up the extra data - over the Bootstrap

	ld a,0
	ld hl,DiskMap_Intro_Screens2 
	ld b,DiskMap_Intro_Screens2_Size
	ld c,DiskMap_Intro_Disk
	ld de,&4000
	call Akuyou_LoadDiscSector





	;call Akuyou_Music_Play

	ld a,3
	call Akuyou_BankSwitch_128k_SetCurrent
	ld a,&40
	call Akuyou_ScreenBuffer_Alt
	; force the cpc to show c0000
	ld hl,&0000
	ld a,&C0
	call &bd1f;mc_screen_offset
	call Akuyou_RasterColors_Init

ret


ShowText0:

		ld hl,SubtitlesEmpty
		ld a,10
		jr ResetText

ShowText1:
		ld hl,Subtitles1
		ld a,&5
		jr ResetText

ResetText:
		ld(OnscreenTextPointer_Plus2-2),hl	
		ld (OnscreenTextPos_Plus1-1),a
		ld a,1
		ld (BossCharNum_Plus1-1),a
		ld a,0
		ld(ShowTextUpdate_Plus1-1),a
		ld a,15
		ld (OnscreenTimer_Plus1-1),a
		call Clear4000

		ld a,0
		di
		call Akuyou_BankSwitch_128k

		call null	:CompiledSprite_Plus2
		ld a,0
		di
		call Akuyou_BankSwitch_128k

		call null	:CompiledSpriteB_Plus2
		call Akuyou_BankSwitch_128k_Reset
		ei



		jp levelloop
	

SubtitlesEmpty: 
db  4,"    "," "+&80
db  4,"    "," "+&80
db &0

Subtitles1: 


db  8,"Once Upon a time..","."+&80
db  5,"In a land far far away..","."+&80
db  3,"There was a girl who was kind"," "+&80
db  1,"to everyone and brought happines","s"+&80
db  4,"everywhere she went <3 <3 <3"," "+&80
db &0


Subtitles2: 
;      .1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0
;      .9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0

db  7,"She isn't in this game!!","!"+&80 
db &0


Subtitles3: 

db  7,"Do you know what happen","s"+&80

db 7,"       when you die?","?"+&80
db &0

Subtitles4: 

db  8,"They say 'if you're goo","d"+&80

db  3,"You go to a place of wonder wher","e"+&80
db  5,"all your dreams will come true'","'"+&80
db &0


Subtitles5: 

db  4,"But 'If you're bad, you'll go t","o"+&80
db  4,"the OTHER PLACE Where you'll b","e"+&80
;      .1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0
;      .9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
db  1,"punished for the bad things you did!!","'"+&80
db &0

Subtitles6: 

db  3,"But what no-one tells you is tha","t"+&80

db  2,"some people are SO bad, they don't"," "+&80
db  12,"go there either.","."+&80
db &0


Subtitles7: 

db  2,"Chibiko was a typical cheerful girl.","."+&80
db &0

Subtitles8: 
;      .1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0
;      .9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
db  10,"She loved animals,","!"+&80
db &0

Subtitles9: 

db  2,"And enjoyed spending time outdoors!","!"+&80
db &0

Subtitles10: 

db  3,"Sometimes she was 'a bit' naughty","."+&80
db &0

Subtitles11: 

db  1," And she didn't really like to study","."+&80
db &0

Subtitles12: 

db 1, "But one time she was very, very bad","."+&80
db &0

Subtitles13: 

db  6,"And took a 'prank' too far","."+&80
db &0

Subtitles14: 
;      .1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0
;      .9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
;      1234567890123456789012345678901234567890
db  2,"When someone does the unforgivable..","."+&80
db &0

Subtitles15: 

db  7,"Judgement comes from above!","."+&80
db &0

Subtitles16: 

db  2,"and strikes them once and for all!","."+&80
db &0
Subtitles17: 

db  2,"Really bad people don't go to heaven","."+&80
db &0
Subtitles18: 

db  1,"and even hell has its limit to wh","o"+&80
db  12,"they'll take!!","."+&80
db &0
Subtitles19: 
;      .1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0
;      .9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
db  2,"You see, when people die,if they've"," "+&80
;      .1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0
;      .9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
db  4,"been 'Really Bad', they dont g","o"+&80

db  10,"'up' or 'down'","'"+&80
db &0
Subtitles20: 

db  2,"They stay where they were as undea","d"+&80
db  6,"monsters, hated by God, an","d"+&80
db  9,"feared by all mankind","!"+&80
db  1,"with an endless thirst for human blood","!"+&80
db &0
Subtitles21: 
Subtitles22:
;      .1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0
;      .9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
db  2,"They live out eternity as Nosferatu",","+&80
db  1,"Vampires, cursed to live by feeding o","n"+&80
db  2,"their former friends and companions!","!"+&80

db &0

Subtitles0: 

db  10," "," "+&80
db &0
ShowBossText:
	ld a,15 :OnscreenTimer_Plus1
	cp 10
	ret c
	ld bc,SubtitlesEmpty :OnscreenTextPointer_Plus2
ShowBossText_StartText:
	;ld hl,&C000
	;call Akuyou_ShowSprite_SetBankAddr
	call Akuyou_SpriteBank_Font
	ld l,&14 :OnscreenTextPos_Plus1
	ld a,1:BossCharNum_Plus1
	ld i,a	; show up to 255 chars
	
ShowBossText_MoreText:
	ei
	halt
	ld a,(bc)

	or a
	jp z,ShowBossText_AllOnscreen ; See if we have reached the end of the string

	ld h,a
	inc bc

	push hl
		call Akuyou_DrawText_LocateSprite

		call Akuyou_DrawText_PrintString
	pop hl
	;inc l
	;inc l
	inc l
	ld a,i
	dec a
	inc bc
	jp nz,ShowBossText_MoreText

	ld a,(bc)
	or a
	jp z,ShowBossText_AllOnscreen ; See if we have reached the end of the string
	ld a,(BossCharNum_Plus1-1)
	inc a
	nop
	nop :ShowTextSpeedup_Plus1
ShowBossTextNoSpeedup:
	ld (BossCharNum_Plus1-1),a

ret
ShowBossText_AllOnscreen:
	jp NoSpeech

	;ld a,(OnscreenTimer_Plus1-1)
	;dec a
	;ld (OnscreenTimer_Plus1-1),a

	;cp 10
	;ret nz
	;ld a,0;9; only one page of text
	;ld (OnscreenTimer_Plus1-1),a
;	ld a,BossText2End-BossText2-20
	;ld a,1
	;ld (BossCharNum_Plus1-1),a

ret
KillObject:; YYYYYXXXXMMMMSSSLLLLPPP
	ld i,a
	ld a,h
	cp &69
	ret z		;not on screen yet


;	ld d,0
;	ld e,objectarraysize
	;y
	inc h;add hl,de 	
	;x
	inc h;	add hl,de 	
	;move
	inc h;	add hl,de 	
	ld a,i
	ld (hl),a
	inc h;	add hl,de 	;spr
	inc h;	add hl,de 	;Life

	;program
ret
SetSprite:; YYYYYXXXXMMMMSSSLLLLPPP
	ld i,a
	ld a,h
	cp &69
	ret z		;not on screen yet


;	ld d,0
;	ld e,objectarraysize
	;y
	inc h;add hl,de 	
	;x
	inc h;	add hl,de 	
	;move
	inc h;	add hl,de 	
	ld a,i
	ld (hl),a
	inc h;	add hl,de 	;spr
	inc h;	add hl,de 	;Life

	;program
ret
SetProgram:; YYYYYXXXXMMMMSSSLLLLPPP
	ld i,a
	ld a,h
	cp &69
	ret z		;not on screen yet


	;ld d,0
	;ld e,objectarraysize
	;y
	inc h;	add hl,de 	
	;x
	inc h;	add hl,de 	
	;move
	inc h;	add hl,de 	

	inc h;	add hl,de 	;spr
	inc h;	add hl,de 	;Life
	ld a,i
	ld (hl),a
	;program
ret
SetMove:; YYYYYXXXXMMMMSSSLLLLPPP
	ld i,a
	ld a,h
	cp &69
	ret z		;not on screen yet


	;ld d,0
	;ld e,objectarraysize
	;y
	inc h;	add hl,de 	
	;x
	inc h;	add hl,de 	
	ld a,i
	ld (hl),a
	;inc h;	add hl,de 	

	;inc h;	add hl,de 	;spr
	;inc h;	add hl,de 	;Life
	
	;program
ret
DoClear4000:
	push hl
	ld hl,Clear4000
	ld (ClearScreenPoint_Plus2-2),hl
	pop hl
ret

Clear4000:

	push hl
	push bc
	push de
		
		ld hl,null;Clear4000
		ld (ClearScreenPoint_Plus2-2),hl

		ld hl,&7FFF
		ld b,256
		ld de,&0000
		call SpFill
		
	pop de
	pop bc
	pop hl
ret
	;ld a,0
	;call Akuyou_BankSwitch_128k
	;call OutroScreen1 CompiledScreen_Plus2;call CompiledScreen1
	;jp Akuyou_BankSwitch_128k_Reset




SpFill:
ld (SpRestoreFill_Plus2-2),sp

SpFillContinue:
ld sp,hl
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
ld hl,&0000
add hl,sp
ld sp,&0000:SpRestoreFill_Plus2
ei
di
djnz SpFillContinue
ei
null:ret

;halttest
;di
;halt
;ret


limit &3FFF
org &3ff0
jp LevelInit; - Level Start &3ff0
jp LevelLoop; - Level loop &3ff3
jp null     ; - Level resume &3ff6
jp null     ; - Level Shutdown &3ff9





save direct "T56-SC1.D02",&2500,&1B00	;address,size...}[,exec_address]



