limit &FFFF
;read "Core.asm"
read "CoreDefs.asm"

limit &E00	
org &50


;
;Rastercolor buffer - 80 bytes (&50
RasterColors_ColorArray1:
	defb 1
	defb 1
	defb 64+20,64+24,64+29,64+11	 :IlluminatedPaletteA_Plus2
RasterColors_ColorArray2:
	defb 1
	defb 1

	defb 64+20,64+12,64+13,64+11	:IlluminatedPaletteB_Plus2
	defb 0
	defb 64+20,64+24,64+29,64+11
	defb 12
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+24,64+29,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
RasterColors_ColorArray3:
	defb 1
	defb 1
	defb 64+20,64+12,64+13,64+11 :IlluminatedPaletteC_Plus2
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
RasterColors_ColorArray4:
	defb 1
	defb 1 
	defb 64+20,64+31,64+14,64+11 :IlluminatedPaletteD_Plus2
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+31,64+14,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+31,64+14,64+11



align 256,&00
StarArraySize equ 255
StarArrayPointer: 	
defs StarArraySize*3,&00


ObjectArraySize equ 60
PlayerStarArraySize equ 36

align 256,&00
PlayerStarArrayPointer: 
defs 64,&00
ObjectArrayPointer:
defs 64,&00
align 256,&00
defs 255*5,&00

;defs ObjectArraySize*6,&00
;defs PlayerStarArraySize*3,&00

;align 256,&00

	

Event_SavedSettings:
defs 4*16,&00



CustomRam:
defs 64 ;  Pos-Tick-Pos-Tick ; enough memory for 16 enemies!





limit &3FF0
org &2000
incbin "Sprites\TITLETEX.SPR"
;incbin "Sprites\LEVEL1A.SPR"

align 256,&00
RasterColors_ColorArray1Alt:
	defb 1
	defb 1				
	defb &54,&55,&4C,&4B	


RasterColors_ColorArray2Alt:
	defb 2	; Switches
	defb 32	;delay			
	defb &54,&58,&5C,&4B	
	defb 64+16-32;delay			
	defb &54,&5D,&53,&4B



RasterColors_ColorArray3Alt:
	defb 2
	defb 48
	defb &54,&46,&5B,&4B
	defb 128
	defb &54,&46,&5a,&4B



RasterColors_ColorArray4Alt:
	defb 3 ; no of switches
	defb 0	;delays			
	defb &54,&46,&5A,&4B
	defb 255	;delays			
	defb &54,&4C,&4D,&4B
	defb 36	;delays			
	defb &54,&46,&5A,&4B



EventStreamArray:

; Load Palette

	defb 0,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&55,&4C,&4B	


	defb 240,26*0+6,5*2+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 2	; Switches
	defb 0	;delay			
	defb &54,&55,&4C,&4B	
	defb 64+16;delay			
	defb &54,&58,&5F,&4B



	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 48
	defb &54,&56,&5B,&4B



	defb 240,26*2+6,5*3+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 3 ; no of switches
	defb 0	;delays			
	defb &54,&56,&5B,&4B
	defb 255	;delays			
	defb &54,&4C,&4D,&4B
	defb 36	;delays			
	defb &54,&56,&5B,&4B
	
defb 4	
	defb 136				; Jump to a different level point
	defw PauseLoop				; pointer
	defb 60					; new time



EventStreamArray_Menu:

;defb 1,128,&24,128+64+60		; Move Static




defb 0,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54	

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*2+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54		


;We will use 4 Paralax layers
; ---------()- (sky)		%11001000
; ------------ (Far)		%11000100
; -----X---X-- (mid)		%11000010	Bank 1
; []=====[]=== (foreground) 	%11000001	Bank 0


; Background L
defb 0,128+4,1,%11000001,0			; Program - Bitshift Sprite... Move - dir Left Slow ... Life - immortal
defb 0,%10010000+15,0				; Save Object settings to Bank 0

defb 0,128+4,1,%11000010,0			; Program - Bitshift Sprite... Move - dir Left Slow ... Life - immortal
defb 0,%10010000+15,1				; Save Object settings to Bank 1

defb 0,128+4,0,&24,0				; Static object
defb 0,%10010000+15,2				; Save Object settings to Bank 2



;Title
defb 0,%01110000+7			; 3 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0,2,12*0+ 24+44,24+16	; 	; Single Object sprite 11 (animated)
defb 	0,3,12*1+ 24+44,24+16	; 	; Single Object sprite 11 (animated)
defb 	0,4,12*2+ 24+44,24+16	; 	; Single Object sprite 11 (animated)
defb 	0,5,12*3+ 24+44,24+16	; 	; Single Object sprite 11 (animated)
defb 	0,6,12*4+ 24+44,24+16	; 	; Single Object sprite 11 (animated)
defb 	0,7,12*5+ 24+44,24+16	; 	; Single Object sprite 11 (animated)

;Chibiko
defb 0,%01110000+3			; 3 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0,0,12*0+ 24,24+64	; 	; Single Object sprite 11 (animated)
defb 	0,1,12*1+ 24,24+64	; 	; Single Object sprite 11 (animated)

;Put Bocchan here!
;defb 0,%01110000+3			; 3 commands at the same timepoint
;defb 	%10010000+0+2				; Load Settings from bank 2
;defb 	0,0,12*0+ 24+160-24,24+200-64	; 	; Single Object sprite 11 (animated)
;defb 	0,1,12*1+ 24+160-24,24+200-64	; 	; Single Object sprite 11 (animated)


;Palette Change
defb 1,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&44,&40	

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&44,&40		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40			












; Load Palette

	defb 2,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&4D,&4A,&4B		;Black,DkBlue,LtYellow,White


	defb 240,26*0+6,5*3+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 3	; Switches
	defb 16	;delay			
	defb &54,&4C,&5B,&4B
	defb 128;delay			
	defb &54,&5C,&5B,&4B
	defb 32;delay			
	defb &54,&58,&4C,&4B


	defb 240,26*1+6,5*3+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 3
	defb 16
	defb &54,&58,&5B,&4B
	defb 72
	defb &54,&40,&5B,&4B
	defb 60
	defb &54,&40,&5F,&4B


	defb 240,26*2+6,5*2+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 2 ; no of switches
	defb 0	;delays			
	defb &54,&40,&47,&59		;Black,Red,Grey,White
	defb 255
	defb &54,&4C,&4E,&4A	;defb &54,&4C,&4E,&49		
	


PauseLoop:
defb 4	
	defb 136				; Jump to a different level point
	defw PauseLoop				; pointer
	defb 60					; new time



Safepalette:
;Safepalette




defb 1,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54	

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*2+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54		


;Palette Change
defb 2,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&44,&40	

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&44,&40		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40			









defb 3,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&5D,&5B,&4B

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&5D,&5B,&4B

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&5D,&5B,&4B		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&5D,&5B,&4B			
	
defb 4	
	defb 136				; Jump to a different level point
	defw PauseLoop				; pointer
	defb 60					; new time


EventStreamFadeOut:
;Palette Change
defb 1,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&44,&40	

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&44,&40		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40			





defb 2,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54	

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*2+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54


defb 3,%10001001			;Call a memory location
	defw	EndLevel
EndLevel:
	call &6969 :FadeOutJump_Plus2

ResetEventStream:
	push hl
		; wipe our memory, to clear out any junk from old levels
		ld de,StarArrayPointer+1
		ld hl,StarArrayPointer
		ld bc,&5FF
		ld (hl),0
		ldir

	pop hl
	;ld hl,EventStreamFadeOut	;Event Stream
	ld de,Event_SavedSettings	;Saved Settings
	call AkuYou_Event_StreamInit
	

ret

LevelInit:

	
	ld hl,&2000		
	ld de,&1000
	call AkuYou_SpritePointerInit




	;call Akuyou_ScreenBuffer_Reset
	;call Akuyou_ScreenBuffer_Init



	;load player setting for color flipping
	call AkuYou_Player_GetPlayerVars
	ld a,(iy-5)
	ld (PaletteNo_Plus1-1),a
	call RasterColorsSetPalette1
	;call Akuyou_RasterColors_Init

	;ld a, StarArraySize
	;ld hl,StarArrayPointer
	;call AkuYou_StarArrayInit_Enemy 

	;ld a, PlayerStarArraySize
	;ld hl,PlayerStarArrayPointer
	;call AkuYou_StarArrayInit_Player 

	ld a,ObjectArraySize
	ld hl,ObjectArrayPointer
	call AkuYou_ObjectArray_Init


;	ld hl,EventStreamArray		;Event Stream
;	ld de,Event_SavedSettings	;Saved Settings
;	call ResetEventStream

	;ld de,Event_SavedSettings	;Saved Settings
	;call AkuYou_Event_StreamInit

	;call Akuyou_ScreenBuffer_Init




ShowTitlePic:
	call Keys_WaitForRelease
	ld hl,EventStreamArray		;Event Stream
	ld de,Event_SavedSettings	;Saved Settings
	call ResetEventStream

	ld a,0
	call Akuyou_BankSwitch_128k_SetCurrent


	call Akuyou_RasterColors_Init

	ld hl,&7000			;Address of the font, We rely on this being loaded by the bootstrap!
	call Akuyou_ShowSprite_SetBankAddr

	ld a,255
	ld i,a		; show up to 255 chars
	
	ld l,&17
	ld bc,TitleText1
	call ShowText

	call Akuyou_Timer_UpdateTimer
	call Akuyou_EventStream_Process
	call Akuyou_ObjectArray_Redraw
ShowTitlePic_Loop:
	

	call Akuyou_Timer_UpdateTimer
	call Akuyou_EventStream_Process
	halt
	call AkuYou_Player_ReadControls

	ld a,ixl
	or %11110001
	cp 255
	jr nz,ShowMenu		; Check for any of the 3 fires being pressed 
	jr ShowTitlePic_Loop

	
ShowMenu:
	ld a,64
	ld (PaletteNo_Plus1-1),a

	call Keys_WaitForRelease
	ld hl,EventStreamArray_Menu		;Event Stream
	call ResetEventStream

	call CLSB

	

	ld hl,&7000			;Address of the font, We rely on this being loaded by the bootstrap!
	call Akuyou_ShowSprite_SetBankAddr

	ld a,255
	ld i,a		; show up to 255 chars
	
	ld l,10
	ld bc,MenuText1
	call ShowText



		ld hl,&1518
		call Akuyou_DrawText_LocateSprite
		call Akuyou_Player_GetHighscore
		ld de,7
		add hl,de
		ld b,8
		call MenuScore_NextDigit


	call Akuyou_Timer_UpdateTimer
	call Akuyou_EventStream_Process
	call Akuyou_ObjectArray_Redraw
ShowMenu_Loop:
	

	call Akuyou_Timer_UpdateTimer

	call Akuyou_EventStream_Process
	halt
	call AkuYou_Player_ReadControls

	ld a,ixl
	or %11110001
	cp 255
	jp nz,StartGame		; Check for any of the 3 fires being pressed 
	

	push hl
	pop ix
	ld a,(ix+7)
	bit 6,a
	jp nz,ShowMenu_NoCredits
	;ShowCredits
	ld hl,ShowCredits
	ld (FadeOutJump_Plus2-2),hl
	ld hl,EventStreamFadeOut
	call ResetEventStream

ShowMenu_NoCredits:
	ld a,(ix+6)
	bit 2,a
	jp z,ConfigureControls

	ld a,(ix+7)
	bit 4,a
	jp z,GameplaySettings

	ld a,(ix+4)
	bit 3,a
	jp z,Introduction


	;call Akuyou_ScreenBuffer_Flip
	jp ShowMenu_Loop


MenuScore_NextDigit:
	push bc
	push hl

		ld a,(hl)		
		add 48 
		call Akuyou_DrawText_CharSprite

	pop hl
	pop bc
	dec hl
	dec b
	jp nz,MenuScore_NextDigit
	ret


	TitleText1:
	db 8, "Press Fire to Continu","e"+&80
	db &0
	MenuText1:
	db  9,"Press Fire To Start","!"+&80
	db  10,""," "+&80
	db  9,"I - Watch the Intr","o"+&80
	db  9,"R - Redefine Control","s"+&80
	db  9,"S - Gameplay Setting","s"+&80
	db  9,"C - Credits & Thank","s"+&80

	db  10,""," "+&80
	db  10,""," "+&80
	db  5,"This Game is Free & Open Sourc","e"+&80
	db  8,"Written 2016 by Keith Sea","r"+&80
	db  10," "," "+&80
	db  10,"Thanks For Playing","!"+&80
	db  10,""," "+&80
	db  10,""," "+&80
	db  10,"HighScore",":"+&80
	;b  "12345678901234567890123456789","0"+&80
	db &0
	
CheatsOn: db &0
Introduction:
	call clsB
	ld hl,	&01FC 				;load Intro
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return


GameplaySettings:

	call Keys_WaitForRelease

	ld hl,BlankMsg
	ld (GamePlaySettingsMessage_Plus2-2),hl

	ld hl,Safepalette
	call ResetEventStream

GameplaySettingsRedraw:

	call CLSB

	ld hl,&7000			;Address of the font, We rely on this being loaded by the bootstrap!
	call Akuyou_ShowSprite_SetBankAddr

	ld a,255
	ld i,a		; show up to 255 chars
	ld l,0
	ld bc,GameplayText 
	call ShowText

	ld a,255
	ld i,a		; show up to 255 chars
	ld l,24
	ld bc,BlankMsg:GamePlaySettingsMessage_Plus2
	call ShowText

GameplaySettings_Loop:
	

	call Akuyou_Timer_UpdateTimer
	call Akuyou_EventStream_Process
	call Akuyou_ObjectArray_Redraw

	call AkuYou_Player_ReadControls

	ld a,ixl
	or %11110001
	cp 255
	jp nz,SaveShowMenu

	push hl
	pop ix
	call AkuYou_Player_GetPlayerVars


	ld a,(ix+8)
	bit 0,a
	jr z,Continues10

	ld a,(ix+8)
	bit 1,a
	jr z,Continues20

	ld a,(ix+7)
	bit 1,a
	jr z,Continues255

	ld a,(ix+7)
	bit 2,a
	jr z,Difficulty1

	ld a,(ix+4)
	bit 6,a
	jr z,Difficulty0

	ld a,(ix+5)
	bit 4,a
	jr z,Difficulty2


	ld a,(ix+3)
	bit 3,a
	jr z,TogglePlusFlicker

	ld a,(ix+6)
	bit 2,a
	jr z,ToggleRasterFlicker
	jp GameplaySettings_Loop

Continues10:
	ld a,10
	ld bc,Continues10Text
	jr SetContinues
Continues20:
	ld a,20
	ld bc,Continues20Text
	jr SetContinues
Continues255:
	ld a,255
	ld bc,Continues255Text
	jr SetContinues


Difficulty1:
	ld a,1
	ld bc,DifficultyEText
	jr SetDifficulty
Difficulty0:
	xor a
	ld bc,DifficultyMText
	jr SetDifficulty
Difficulty2:
	ld a,2
	ld bc,DifficultyHText
	jr SetDifficulty

TogglePlusFlicker:
	ld a,(iy-4)
	xor 64
	ld (iy-4),a
CheckToggle:
	jr z,SetToggleOn
	cp 255
	jr z,SetToggleOn
jr SetToggleOff

ToggleRasterFlicker:
	ld a,(iy-5)
	xor 64
	ld (iy-5),a
	jr CheckToggle

SetDifficulty:
	ld (iy+7),a
jr ShowGameplaySetting
SetToggleOff:
	ld bc,ToggleOffText
	jr ShowGameplaySetting
SetToggleOn:
	ld bc,ToggleOnText
	jr ShowGameplaySetting
SetContinues:
	ld (iy+6),a
ShowGameplaySetting:

	ld (GamePlaySettingsMessage_Plus2-2),bc
	jp GameplaySettingsRedraw


GameplayText:
	db  9,"Gameplay Options","!"+&80
	db  10,""," "+&80
	db  8,"Continues",":"+&80
	db  10,""," "+&80
	db  10,"1 - 10 Credit","s"+&80
	db  10,"2 - 20 Credit","s"+&80
	db  10,"3 - 255 Credit","s"+&80
	db  10,""," "+&80
	db  8,"Enemy Difficulty",":"+&80
	db  10,""," "+&80
	db  10,"E.Easy"," "+&80
	db  10,"M.Medium"," "+&80
	db  10,"H.Hard"," "+&80
	db  10,""," "+&80
	db  8,"Effects",":"+&80
	db  10,""," "+&80
	db  10,"P.Plus Sprite Flicker"," "+&80
	db  10,"R.Raster Color Flicker"," "+&80

	db  10,""," "+&80
	db  9,"Press Fire to go bac","k"+&80
	db  0

BlankMsg:db  4,""," "+&80,0

Continues10Text: db  4,"      C10 - Good Luck!!","!"+&80,0
Continues20Text: db  4,"     C20 - Don't mess up","!"+&80,0
Continues255Text: db  4,"C255 - You'd better damn win","!"+&80,0

DifficultyEText: db  4,"Easy-Don't forget your diaper","!"+&80,0
DifficultyMText: db  4,"     Normal - Fair Enough","!"+&80,0
DifficultyHText: db  4,"Hard - I hope you like pain!","!"+&80,0

ToggleOnText: db  15,"Enable","d"+&80,0
ToggleOffText: db 15,"Disable","d"+&80,0

StartGame:	
	call clsB
	ld hl,	&0101 				;load level 1
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return

ShowCredits:	
	call Keys_WaitForRelease
	call CLSB
	xor a
	ld (CheatsOn),a

	ld hl,Safepalette
	call ResetEventStream


	ld hl,&7000			;Address of the font, We rely on this being loaded by the bootstrap!
	call Akuyou_ShowSprite_SetBankAddr

	ld a,255
	ld i,a		; show up to 255 chars
	
	ld l,2
	ld bc,Credits_TextString
	call ShowText


ShowCredits_Loop:
	

	call Akuyou_Timer_UpdateTimer
	call Akuyou_EventStream_Process
	call Akuyou_ObjectArray_Redraw


	call AkuYou_Player_ReadControls



	ld a,ixl
	or %11110001
	cp 255
	jp nz,ShowMenu

	; Cheatmenu, Press F6 on credits, then 6 twice
	push hl
	pop ix

	ld a,(CheatsOn)
	cp 0
	jr z,cheatStage0	; cheating isnt armed
	cp 1
	jr z,cheatStage1	; cheating isnt armed
	cp 2
	jr z,cheatStage2	; cheating isnt armed
	cp 3
	jp z,ShowCheats		; Cheat!


cheatStage0:
	ld a,(ix+0)
	bit 4,a
	call z,Cheater
	jr ShowCredits_Loop
cheatStage1:
	ld a,(ix+6)
	bit 0,a
	call z,Cheater
	jr ShowCredits_Loop
cheatStage2:
	ld a,(ix+0)
	bit 4,a
	call z,Cheater
	jr ShowCredits_Loop

Cheater:
	call Keys_WaitForRelease
	ld a,(CheatsOn)
	inc a
	ld (CheatsOn),a
	ret

	Credits_TextString: 

db 12,"Chibi Akuma(s)","!"+&80
db 17,"V1.01"," "+&80
db 5,""," "+&80

db 7, "http://www.ChibiAkumas.co","m"+&80
db 5, " "," "+&80

db 8,"A Free Open Source Gam","e"+&80
db 7,"Written By Keith Sear 201","6"+&80
db 5,""," "+&80

db 4, "This Game would not be possibl","e"+&80
db 4, "without the following Software",":"+&80
db 7, "WinApe, ConvImgCpc, Krit","a"+&80
db 5,""," "+&80

db 6, "And the following Websites",":"+&80
db 6,"cpcwiki.eu, cantrell.org.u","k"+&80
db 10,"cpctech.cpc-live.co","m"+&80
db 11,"tutorials.eeems.c","a"+&80
db 5,""," "+&80
;      .1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0
;      .9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
db 9,"Press Fire to Continu","e"+&80
db &00

CLSB:
	; clear the screen
	di
	call Akuyou_ScreenBuffer_GetActiveScreen
	ld d,a
	ld h,a
	ld e,&01
	ld BC,&3FFF
	ld l,&00
	ld a,0
	ld (hl),a
	ldir
	ei
ret

Keys_WaitForRelease:

	ld b,10
Keys_WaitForRelease_More:
	push bc
	call AkuYou_Player_ReadControls
	pop bc
	ld a,(hl)
	inc hl
	cp 255
	jp c,Keys_WaitForRelease
	djnz Keys_WaitForRelease_More
ret

	;call RasterColors_Reset
LevelLoop:
	;jp ShowCheats
	jp ShowMenu
	

LevelShutdown:

ret

ShowCheats:
	call cls
	ld l,4
	ld bc,CheatsText
	call ShowText

ShowCheats2:
	call AkuYou_Player_ReadControls
	push hl
	pop ix

	ld a,(ix+4)	
	bit 6,a			;M
	call z,ShowMenu
	
	ld a,(ix+8)	
	bit 0,a			;1
	call z,StartGame
	bit 1,a			;2
	call z,StartLevel2

	ld a,(ix+7)	
	bit 1,a			;3
	call z,StartLevel3
	;ld a,(ix+7)	
	bit 0,a			;4
	call z,StartLevel4

	ld a,(ix+6)	
	bit 1,a			;5
	call z,StartLevel5
	;ld a,(ix+6)	
	bit 0,a			;6
	call z,StartLevel6

	ld a,(ix+5)	
	bit 1,a			;7
	call z,StartLevel7
	;ld a,(ix+5)	
	bit 0,a			;8
	call z,StartLevel8

	ld a,(ix+4)	
	bit 1,a			;9
	call z,StartLevel9


	ld a,(ix+7)	
	bit 2,a			;E
	call z,	StartEndSequence





	ld a,(ix+3)	
	bit 3,a			;P
	call z,	CheatMode

jp ShowCheats2

CheatMode:
	ld a,1
	call Akuyou_Player_CheatMode


	ld l,20
	ld bc,CheatsONText
	call ShowText
	ret

StartLevel2:	
	ld hl,	&0102 				;load level 2
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return

StartLevel3:	
	ld hl,	&0103 				;load level 3
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return
StartLevel4:	
	ld hl,	&0104 				;load level 4
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return
StartLevel5:	
	ld hl,	&0105 				;load level 5
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return
StartLevel6:	
	ld hl,	&0106 				;load level 6
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return
StartLevel7:	
	ld hl,	&0107 				;load level 7
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return
StartLevel8:	
	ld hl,	&0108 				;load level 8
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return
StartLevel9:	
	ld hl,	&01FA 				;load level 9
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return
StartEndSequence:	
	ld hl,	&01FB 				;load EndSetquence
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return



CheatsText: 
db  6,"Tools for Cheating Bastards","!"+&80
db  10,""," "+&80
db  10,"1-9: Start Stage"," "+&80
db  10,""," "+&80
db  10,"E: End Sequence"," "+&80
db  05,""," "+&80
db  10,"P: Full power player"," "+&80
db  05,""," "+&80
db  10,"M: Main Menu"," "+&80
;b  "12345678901234567890123456789","0"+&80
db &0
CheatsONText:
db  10,"Trainer Enabled"," "+&80,0
ShowText:
	push hl
	;ld hl,&C000
	ld hl,&7000
	call Akuyou_ShowSprite_SetBankAddr
	pop hl

ShowText_MoreText:
	ld a,255
	ld i,a	; show up to 255 chars

	ld a,(bc)
	ld h,a
	inc bc

	push hl
		call Akuyou_DrawText_LocateSprite

		call Akuyou_DrawText_PrintString
	pop hl

	inc l
	ld a,i
	dec a
	ld i,a
	inc bc

	ld a,(bc)
	or a
	jp nz,ShowText_MoreText

	
ret



ShowHex:

	push af         ;store original byte value
	rrca            
	rrca
	rrca
	rrca
	call ShowHexDigit
	pop af          ;retrieve original byte value

ShowHexDigit:
;	and %00001111   ;isolate lower nibble. (This contains the digit value 0...15)
;	add a,"0"       ;add ASCII for 0. Digits 0...9 become "0"..."9", digits 10..15
;	cp "9"+1        
;	jr c,ShowHexDigitNum     ;if number is in digit range 0...9, display digit
;	add a,"A"-"9"-1 ;modify ASCII value so that digits in the range 10...15
and %00001111   ;isolate lower nibble. (This contains the digit value 0...15)
cp &a           ;Less than 10?  Set carry if so
sbc a,&69
daa             ;Because previous instruction was a subtract operation this
                ;is known as 'das' in x86
ShowHexDigitNum:
	jp Akuyou_DrawText_CharSprite   ;display digit







;***************************************************************************************************

;					Configure Controls

;***************************************************************************************************






RasterColorsSetPalette1:
	ld a,1
	ld bc,RasterColors_ColorArray1
	ld de,RasterColors_ColorArray2
	ld hl,RasterColors_ColorArray3
	ld ix,RasterColors_ColorArray4
	ld iy,PaletteSwitcher
jp Akuyou_RasterColors_SetPointers

PaletteSwitcher:
	ld a,0:PaletteNo_Plus1
	cpl	
	ld (PaletteNo_Plus1-1),a
	or a
	jp nz,RasterColorsSetPalette1
RasterColorsSetPalette2:
	ld a,1
	ld bc,RasterColors_ColorArray1Alt
	ld de,RasterColors_ColorArray2Alt
	ld hl,RasterColors_ColorArray3Alt
	ld ix,RasterColors_ColorArray4Alt
	ld iy,PaletteSwitcher
jp Akuyou_RasterColors_SetPointers



ConfigureControls:
	ld hl,	&0002 				;Set Controls
	call	Akuyou_ExecuteBootStrap	; Start the game, no return
SaveShowMenu:
	call CLSB
	ld hl,	&0003 				;Save Settings
	call	Akuyou_ExecuteBootStrap	; Start the game, no return

	call Akuyou_RasterColors_Init
jp ShowMenu



CLS:
	; clear the screen
	ld a,&C0
	ld d,a
	ld h,a
	ld e,&01
	ld BC,&3FFF
	ld l,&00
	xor a
	ld (hl),a
	ldir
ret






null:ret

limit &3FFF
org &3ff0
jp LevelInit; - Level Start &3ff0
jp LevelLoop; - Level loop &3ff3
jp null     ; - Level resume &3ff6
jp null     ; - Level Shutdown &3ff9





save direct "T08-SC1.D01",&2000,&2000	;address,size...}[,exec_address]


