read "CoreDefs.asm"

limit &E00	
org &50


;
;Rastercolor buffer - 80 bytes (&50
RasterColors_ColorArray1:
	defb 1
	defb 1
	defb 64+20,64+24,64+29,64+11	 :IlluminatedPaletteA_Plus2
RasterColors_ColorArray2:
	defb 1
	defb 1

	defb 64+20,64+12,64+13,64+11	:IlluminatedPaletteB_Plus2
	defb 0
	defb 64+20,64+24,64+29,64+11
	defb 12
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+24,64+29,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
RasterColors_ColorArray3:
	defb 1
	defb 1
	defb 64+20,64+12,64+13,64+11 :IlluminatedPaletteC_Plus2
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
RasterColors_ColorArray4:
	defb 1
	defb 1 
	defb 64+20,64+31,64+14,64+11 :IlluminatedPaletteD_Plus2
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+31,64+14,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+31,64+14,64+11



align 256,&00
StarArraySize equ 255
StarArrayPointer: 	
defs StarArraySize*3,&00


ObjectArraySize equ 60
PlayerStarArraySize equ 36

align 256,&00
PlayerStarArrayPointer: 
defs 64,&00
ObjectArrayPointer:
defs 64,&00
align 256,&00
defs 255*5,&00

;defs ObjectArraySize*6,&00
;defs PlayerStarArraySize*3,&00

;align 256,&00

	

Event_SavedSettings:
defs 4*16,&00


CustomRam:
defs 64 ;  Pos-Tick-Pos-Tick ; enough memory for 16 enemies!


limit &4000
org &E00	


;limit &2000
;org &1000
;incbin "Sprites\PLAYER.SPR"

limit &4000
org &2000
;incbin "Sprites\LEVEL1A2.SPR"
incbin "Sprites\LEVEL1A.SPR"



org &3800

RasterColors_ColorArray1Alt:
	defb 1
	defb 1				
	defb &54,&55,&4A,&4B		;Black,DkBlue,LtYellow,White
RasterColors_ColorArray2Alt:
	defb 2	; Switches
	defb 16	;delay			
	defb &54,&5D,&59,&4B
	defb 16	;delay			
	defb &54,&58,&5F,&4B
RasterColors_ColorArray3Alt:
	defb 0
;	defb 1
;	defb &54,&54,&54,&54		 :IlluminatedPaletteCAlt_Plus2
RasterColors_ColorArray4Alt:
	defb 2 ; no of switches
	defb 0	;delays			
	defb &54,&58,&51,&4B		;Black,Red,Grey,White
	defb 32
	defb &54,&4C,&51,&4B	




;limit &3000


;org &2E00

;Event_SavedSettings:
;defs 4*16,&00



read "Eventstreamdefinitions.asm"




EventStreamArray:

;defb 1,128,&24,128+64+60		; Move Static




defb 0,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54	

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*2+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54		



; Define the background

defb 0,240+1,0,41				; (Time,Cmd,Off,Bytes) Load 41 bytes into the background - 41 bytes is the limit

defb &F0,&F0	;1; first line
defb 196,&D0	;2; line num, New byte
defb 190,&70	;3
defb 186,&A0	;4
defb 180,&50	;5
defb 176,&80	;6
defb 170,&20	;7
defb 166,&00	;8
defb 160,&00	;9
defb 36,&20	;10
defb 32,&80	;11
defb 28,&50	;12
defb 24,&A0	;13
defb 20,&70	;14
defb 16,&D0	;15
defb 12,&69	;16
defb 10,&2D	;17
defb 08,&2F	;18
defb 06,&8f	;19
defb 02,&0F	;20
defb 255

;We will use 4 Paralax layers
; ---------()- (sky)		%11001000
; ------------ (Far)		%11000100
; -----X---X-- (mid)		%11000010	Bank 1
; []=====[]=== (foreground) 	%11000001	Bank 0



defb 0,evtReprogram_PowerupSprites,128+38,128+39,128+40,128+16	; Define powerup sprites

; Background L
defb 0,128+4,1,%11000001,0			; Program - Bitshift Sprite... Move - dir Left Slow ... Life - immortal
defb 0,%10010000+15,0				; Save Object settings to Bank 0

defb 0,128+4,1,%11000010,0			; Program - Bitshift Sprite... Move - dir Left Slow ... Life - immortal
defb 0,%10010000+15,1				; Save Object settings to Bank 1

; Rock Chick
defb 0,%01110000+3			; 3 commands at the same timepoint
defb 	128+4,%01100000+11,&22,%11000000+1	; Program - Fire Burst... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
defb 	%10000101,128+	1			; Sprite 1 Frame animater
defb 	%10010000+15,2				; Save Object settings to Bank 2


;defb 0,%01110000+3			; 3 commands at the same timepoint
;defb 	128+4,%01100000+11,&22,%11000000+4	; Program - Burst left slow... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
;defb 	%10000101,128+	1			; Sprite 1 Frame animater
;defb 	%10010000+15,2				; Save Object settings to Bank 2

; Skull bomber
defb 0,%01110000+3			; 3 commands at the same timepoint
defb 	128+4,%00100000+22,&23,%11000000+4	; Program - Fire Down Fast... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
defb 	%10000101,128+	37			; Sprite 1 Frame animater
defb 	%10010000+15,3				; Save Object settings to Bank 2

; Ant Attacker
defb 0,%01110000+3			; 3 commands at the same timepoint
defb 	128+4,%01100000+1,&23,%11000000+4	; Program - Bitshift Sprite... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
defb 	%10000101,128+	0			; Sprite 1 Frame animater
defb 	%10010000+15,4				; Save Object settings to Bank 2

; Skeleton Crawler
defb 0,%01110000+3			; 3 commands at the same timepoint
defb 	128+4,%10000000+11,&22,%11000000+3	; Program - Bitshift Sprite... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
defb 	%10000101,128+	36			; Sprite 1 Frame animater
defb 	%10010000+15,5				; Save Object settings to Bank 5

; SpliceFace
defb 0,%01110000+3			; 3 commands at the same timepoint
defb 	128+4,%10000000+13,&25,%11000000+4	; Program - Starburst ... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
defb 	%10000101,128+	34			; Sprite 1 Frame animater
defb 	%10010000+15,6				; Save Object settings to Bank 6

; BoniBurd
defb 0,%01110000+3			; 3 commands at the same timepoint
defb 	128+4,%10000000+2,&22,%11000000+3	; Program - Bitshift Sprite... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
defb 	%10000101,128+	2			; Sprite 1 Frame animater
defb 	%10010000+15,7	

; Skull Gang
defb 0,%01110000+3			; 3 commands at the same timepoint
defb 	128+4,%00100000+16,%10100001,%11000000+3	; Program - Fire Left... Move - wave 10101100 ... Hurt by bullets, hurts player, life 4
defb 	%10000101,128+	35			; Sprite 1 Frame animater
defb 	%10010000+15,8	

; Eyeclopse
defb 0,%01110000+3			; 3 commands at the same timepoint
defb 	128+4,%01100000+11,%10101100,%11000000+3	; Program - Fire Left... Move - wave 10101100 ... Hurt by bullets, hurts player, life 4
defb 	%10000101,128+	7			; Sprite 1 Frame animater
defb 	%10010000+15,9	

;Add To Background
defb 0,134			


;defb 0,128+1,1				; Program / bitshift sprite
;moon
;defb 0,128,%11001000,0			; Move 	  / dir Left Slow ... Life - immortal
defb 0,128+4,1,%11001000,0			; Program - Bitshift Sprite... Move - dir Left Slowest ... Life - immortal
defb 0,0,	3,24+ 160 -16 ,24+ 0		; single sprite


;Castle
defb 0,128,%11000010,0			; Move 	  / dir Left Slow ... Life - immortal
;defb 0,0,	12,24+ 120+5  ,24+ 30+50		; single sprite
;defb 0,0,	12,24+ 129+5  ,24+ 30+50		; single sprite
defb 0,0,	4,24+ 120  ,24+ 40		; single sprite
defb 0,0,	5,24+ 132  ,24+ 40		; single sprite


defb 0,0,	14,24+ 100  ,24+ 40+80		; single sprite
defb 0,0,	15,24+ 152  ,24+ 40+80		; single sprite

defb 0,0,	13,24+ 90  ,24+ 40+100		; single sprite
defb 0,0,	13,24+ 162  ,24+ 40+100		; single sprite

;Burning bloke
defb 0,%01110000+3			; 3 commands at the same timepoint
defb 	%10010000+0+1				; Load Settings from bank 1
defb 	129,0					; Change to program 0 (normal)
defb 	0,128+	11,50+24,90+24	; 	; Single Object sprite 11 (animated)





;Clouds (3 wide)
defb 0,%01110000+6			; 2 commands at the same timepoint
defb 	evtAddToBackground
defb 	128+4,0,%11000100,0			; Move 	  / dir Left Slow ... Life - immortal
defb 	0, 41,159+24,10+28	; 	; Single Object / 
defb 	0, 42,159+24+12,10+28	; 	; Single Object / 
defb 	0, 43,159+24+24,10+28	; 	; Single Object / 
defb 	evtAddToForeground




;Spikeyrock
defb 0,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+0				; Load Settings from bank 0
defb 	48+   2   ,24+ 100,24+24+ 128,24,		8,9 ; Three sprites, 
;defb 	0,	8 ,24+ 110  ,24+ 128		; single sprite
;defb 	0,	9 ,24+ 110  ,24+ 128+24		; single sprite
;defb 	0,	10,24+ 110  ,24+ 128+24+24	; single sprite

;defb 1,128,%10000111,0+0+2		; Seeker / Life 60, hurts player (64) and Hit by bullets (128)

;defb 1,0,	128+01,110,110	; 
;defb 3,0,	128+01,100,100

;defb 5,128,&1c,128+64+ 64			; Move dir up

;Palette Change
defb 1,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&44,&40	

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&44,&40		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40			











; Load Palette

	defb 2,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&55,&4A,&4B		;Black,DkBlue,LtYellow,White

	;defb 0,240,6,6			; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 5
	;defb 1				
	;defb &54,&55,&43,&4B		;Black,DkBlue,LtYellow,White

	defb 240,26*0+6,5*2+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 2	; Switches
	defb 16	;delay			
	defb &54,&5D,&59,&4B
	defb 16	;delay			
	defb &54,&58,&5F,&4B



	defb 240,26*1+6,1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0

	defb 240,26*2+6,5*2+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 2 ; no of switches
	defb 0	;delays			
	defb &54,&58,&53,&4B		;Black,Red,Grey,White
	defb 32
	defb &54,&4C,&53,&4B	 ;5b	
	
	
	;defb 1				
	;defb &54,&4C,&56,&4B

; start of level
defb 2,evtCallAddress
	defw RasterColorsStartPalleteFlip

; rock chick enemy
defb 5,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+8				; Row 16, last Column, Last Sprite



;defb 5,128+1,%00100000+10			; Starbursts
;defb 5,0,	128+01,150,24+180	

;defb 6,128+1,1				; Program / bitshift sprite
;defb 6,128,%11001000,0			; Move 	  / dir Left Slow ... Life - immortal
;defb 6,128,%11100000,0			; Move 	... Life - immortal
;defb 6,0,	04,110,110	; 	; Single Object / 

; Rock Pt 1
defb 10,%01110000+3			; 2 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+0				; Load Settings from bank 0
defb 	0,	22,160+24,172+28	; 	; Single Object / 

;Cross
defb 13,%01110000+3			; 3 commands at the same timepoint
defb 	%10010000+0+1				; Load Settings from bank 1
defb 	0,17,160+24,110+24	; 	; Single Object sprite 11 (animated)
defb 	evtAddToForeground


; rock chick enemy
defb 15,%01110000+3			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+6				; Row 16, last Column, Last Sprite
defb 	0+10				; Row 16, last Column, Last Sprite


; Rock Pt 2
defb 16,%01110000+4			; 2 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+0				; Load Settings from bank 0
defb 	0,	23,160+24,172+28	; 	; Single Object / 
defb 	evtAddToForeground

; Powerup Rate
defb 17,%01110000+2			; 2 commands at the same timepoint
defb 	128+4,3,&22,64+63	; Program - Bitshift Sprite... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
defb 	0,128+ 39,160+24,50+24	; 	; Single Object sprite 11 (animated)


; Rock Pt 3
defb 22,%01110000+4			; 2 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+0				; Load Settings from bank 0
defb 	0,	24,160+24,172+28	; 	; Single Object / 
defb 	evtAddToForeground



; Powerup Fire
;defb 23,%01110000+2			; 2 commands at the same timepoint
;defb 	128+4,3,&22,64+8	; Program - Bitshift Sprite... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
;defb 	0,128+ 40,160+24,50+24	; 	; Single Object sprite 11 (animated)


; rock chick enemy
defb 25,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+8				; Row 16, last Column, Last Sprite

; rock chick enemy
defb 30,%01110000+3			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+6				; Row 16, last Column, Last Sprite
defb 	0+10				; Row 16, last Column, Last Sprite

; rock chick enemy
defb 35,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+8				; Row 16, last Column, Last Sprite


;Cross
defb 40,%01110000+4			; 3 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+1				; Load Settings from bank 1
defb 	0,18,160+24,85+24	; 	; Single Object sprite 11 (animated)
defb 	evtAddToForeground




;Skull Bomber
defb 45,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+3				; Load Settings from bank 3
defb 	0+3				; Row 16, last Column, Last Sprite

;Ant
defb 45,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+4				; Load Settings from bank 4
defb 	0+13				; Row 16, last Column, Last Sprite



;Burning bloke
defb 55,%01110000+5			; 3 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+1				; Load Settings from bank 1
defb 	129,0					; Change to program 0 (normal)
defb 	0,128+	11,160+24,90+24	; 	; Single Object sprite 11 (animated)
defb 	evtAddToForeground



; Boniburd
defb 65,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+7				; Load Settings from bank 5
defb 	evtSingleSprite,TwoFrameSprite+	2,160+24-24,24+16

;  SpikyRock
defb 67,%01110000+4			; 2 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+0				; Load Settings from bank 0
defb 	48+   3   ,160+24,24+ 128,24,		8,9,10 ; Three sprites, 
defb 	evtAddToForeground

; rock enemy
;defb 70,%01110000+3			; 2 commands at the same timepoint
;defb 	%10010000+0+2				; Load Settings from bank 2
;defb 	0+6				; Row 16, last Column, Last Sprite
;defb 	0+10				; Row 16, last Column, Last Sprite

; rock chick enemy
defb 75,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+8				; Row 16, last Column, Last Sprite

; rock chick enemy
defb 80,%01110000+3			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+6				; Row 16, last Column, Last Sprite
defb 	0+10				; Row 16, last Column, Last Sprite


; boniburd
defb 84,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+7				; Load Settings from bank 5
defb 	evtSingleSprite,TwoFrameSprite+	2,160+24-24,24+16

;Skeleton walker
defb 85,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+5				; Load Settings from bank 5
defb 	0+13				; Row 16, last Column, Last Sprite



;Cross
defb 88,%01110000+4			; 3 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+1				; Load Settings from bank 1
defb 	0,18,160+24,85+24	; 	; Single Object sprite 11 (animated)
defb 	evtAddToForeground


; Powerup Drone
defb 90,%01110000+2			; 2 commands at the same timepoint
defb 	128+4,3,&22,64+63	; Program - Bitshift Sprite... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
defb 	0,128+ 38,160+24,150+24	; 	; Single Object sprite 11 (animated)



;Grave
defb 95,%01110000+4			; 3 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+0				; Load Settings from bank
defb 	0,21,160+24,170+24	; 	; Single Object sprite 11 (animated)
defb 	evtAddToForeground

; SpliceFace
defb 100,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+6				; Load Settings from bank 6
defb 	0,128+34,24,100+24	; 	; Single Object / 



; rock chick enemy
defb 110,%01110000+3			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+6				; Row 16, last Column, Last Sprite
defb 	0+10				; Row 16, last Column, Last Sprite

; rock chick enemy
defb 115,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+8				; Row 16, last Column, Last Sprite


;Clouds (3 wide)
defb 120,%01110000+6			; 2 commands at the same timepoint
defb 	evtAddToBackground
defb 	128+4,0,%11000100,0			; Move 	  / dir Left Slow ... Life - immortal
defb 	0, 41,159+24,10+28	; 	; Single Object / 
defb 	0, 42,159+24+12,10+28	; 	; Single Object / 
defb 	0, 43,159+24+24,10+28	; 	; Single Object / 
defb 	evtAddToForeground



; rock chick enemy
defb 120,%01110000+3			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+6				; Row 16, last Column, Last Sprite
defb 	0+10				; Row 16, last Column, Last Sprite

;Grave
defb 122,%01110000+4			; 3 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+0				; Load Settings from bank
defb 	0,21,160+24,170+24	; 	; Single Object sprite 11 (animated)
defb 	evtAddToForeground

; rock chick enemy
defb 125,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+8				; Row 16, last Column, Last Sprite

; rock chick enemy
defb 127,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+8				; Row 16, last Column, Last Sprite


;Burning bloke
defb 129,%01110000+3			; 3 commands at the same timepoint
defb 	%10010000+0+1				; Load Settings from bank 1
defb 	129,0					; Change to program 0 (normal)
defb 	0,128+	11,160+24,90+24	; 	; Single Object sprite 11 (animated)


; rock chick enemy
defb 130,%01110000+3			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+6				; Row 16, last Column, Last Sprite
defb 	0+10				; Row 16, last Column, Last Sprite

; rock chick enemy
defb 135,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+8				; Row 16, last Column, Last Sprite



;Cross
defb 140,%01110000+4			; 3 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+1				; Load Settings from bank 1
defb 	0,19,160+24,103+24	; 	; Single Object sprite 11 (animated)
defb 	evtAddToForeground

; SpliceFace
defb 150,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+6				; Load Settings from bank 6
defb 	0,128+34,24,100+24	; 	; Single Object / 

; Powerup Drone
defb 150,%01110000+2			; 2 commands at the same timepoint
defb 	128+4,3,&22,64+63	; Program - Bitshift Sprite... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
defb 	0,128+ 38,160+24,150+24	; 	; Single Object sprite 11 (animated)



; Eyeclopse s
defb 160,%01110000+4			; 2 commands at the same timepoint
defb 	%10010000+0+9				; Load Settings from bank 5
defb 	0+7	
defb 	131,%10101111				; change Move
defb 	0+12	

; rock chick enemy
defb 165,%01110000+3			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+6				; Row 16, last Column, Last Sprite
defb 	0+10				; Row 16, last Column, Last Sprite



;Grave
defb 167,%01110000+4			; 3 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+0				; Load Settings from bank
defb 	0,20,160+24,173+24	; 	; Single Object sprite 11 (animated)
defb 	evtAddToForeground


; rock chick enemy
defb 170,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+8				; Row 16, last Column, Last Sprite


; Eyeclopse s
defb 180,%01110000+4			; 2 commands at the same timepoint
defb 	%10010000+0+9				; Load Settings from bank 5
defb 	0+7	
defb 	131,%10101111				; change Move
defb 	0+12	

;Cross
defb 185,%01110000+4			; 3 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+1				; Load Settings from bank 1
defb 	0,19,160+24,107+24	; 	; Single Object sprite 11 (animated)
defb 	evtAddToForeground


; Skull Gang
defb 190,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+8				; Load Settings from bank 5
defb 	0+7	


;Clouds (3 wide)
defb 200,%01110000+6			; 2 commands at the same timepoint
defb 	evtAddToBackground
defb 	128+4,0,%11000100,0			; Move 	  / dir Left Slow ... Life - immortal
defb 	0, 41,159+24,10+28	; 	; Single Object / 
defb 	0, 42,159+24+12,10+28	; 	; Single Object / 
defb 	0, 43,159+24+24,10+28	; 	; Single Object / 
defb 	evtAddToForeground



; rock chick enemy
defb 200,%01110000+3			; 2 commands at the same timepoint
defb 	%10010000+0+2				; Load Settings from bank 2
defb 	0+6				; Row 16, last Column, Last Sprite
defb 	0+10				; Row 16, last Column, Last Sprite


; boniburd
defb 220,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+7				; Load Settings from bank 5
defb 	evtSingleSprite,TwoFrameSprite+	2,160+24-24,24+16

;Skeleton walker
defb 220,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+5				; Load Settings from bank 5
defb 	0+13				; Row 16, last Column, Last Sprite


;Grave
defb 221,%01110000+4			; 3 commands at the same timepoint
defb 	evtAddToBackground
defb 	%10010000+0+0				; Load Settings from bank
defb 	0,20,160+24,176+24	; 	; Single Object sprite 11 (animated)
defb 	evtAddToForeground


;Skull Bomber
defb 225,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+3				; Load Settings from bank 3
defb 	0+3				; Row 16, last Column, Last Sprite

;Ant
defb 225,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+4				; Load Settings from bank 4
defb 	0+13				; Row 16, last Column, Last Sprite




; SpliceFace
defb 230,%01110000+4			; 2 commands at the same timepoint
defb 	%10010000+0+6				; Load Settings from bank 6
defb    %10000011,&23			; Change Move
defb 	0,128+34,24,50+24	; 	; Single Object / 
defb 	0,128+34,24,150+24	; 	; Single Object / 



; SpliceFace
defb 232,%01110000+3			; 2 commands at the same timepoint
defb 	%10010000+0+6				; Load Settings from bank 6
defb 	0,128+34,24,50+24	; 	; Single Object / 
defb 	0,128+34,24,150+24	; 	; Single Object / 


;Skull Bomber
defb 235,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+3				; Load Settings from bank 3
defb 	0+3				; Row 16, last Column, Last Sprite

;Ant
defb 235,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+4				; Load Settings from bank 4
defb 	0+13				; Row 16, last Column, Last Sprite

;Skull Bomber
defb 245,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+3				; Load Settings from bank 3
defb 	0+3				; Row 16, last Column, Last Sprite

;Ant
defb 245,%01110000+2			; 2 commands at the same timepoint
defb 	%10010000+0+4				; Load Settings from bank 4
defb 	0+13				; Row 16, last Column, Last Sprite



defb 250,%01110000+2			; 2 commands at the same timepoint
defb 	128+4,0,%11000100,0			; Move 	  / dir Left Slow ... Life - immortal
defb 	0, 43,160+24,10+28	; 	; Single Object / 



defb 5,%10001001			;Call a memory location
defw	ClearBadguys
;Palette Change
LevelEndAnim:
defb 5,%01110000+2			; 3 commands at the same timepoint
defb evtSetProgMoveLife,prgMovePlayer,&24,10
defb 	0,128+	20,140+24,100+24	; 	; Single Object sprite 11 (animated)

;Palette Change
defb 6,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&44,&40	

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&44,&40		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40			




defb 7,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54	

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*2+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

defb 8,evtCallAddress			;Call a memory location
defw	EndLevel


EndLevel:
	pop hl	;
	ld hl,	&0102 				;load level 2
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return

; stream examples

; Three Linked Background objects
;defb 1,128+1,1				; Program / bitshift sprite
;defb 1,128,%11000010,0			; Move 	  / dir Left Slow ... Life - immortal
;defb 10,0,	22,110,111	; 	; Single Object / 
;defb 22,0,	23,110,111	; 	; Single Object / 
;defb 34,0,	24,110,111	; 	; Single Object / 




; Three Linked Background objects Faster
;defb 1,128+1,1				; Program / bitshift sprite
;defb 1,128,%11000001,0			; Move 	  / dir Left Slow ... Life - immortal
;defb 10,0,	22,160+24,175+24	; 	; Single Object / 
;defb 16,0,	23,160+24,175+24	; 	; Single Object / 
;defb 22,0,	24,160+24,175+24	; 	; Single Object / 
null: ret


limit &4000





;org &3f00
LevelInit:


	ld a, StarArraySize
	ld hl,StarArrayPointer
	call AkuYou_StarArrayInit_Enemy 

	ld a, PlayerStarArraySize
	ld hl,PlayerStarArrayPointer
	call AkuYou_StarArrayInit_Player 

	ld a,ObjectArraySize
	ld hl,ObjectArrayPointer
	call AkuYou_ObjectArray_Init


	call AkuYou_Player_GetPlayerVars
	ld a,(iy-5)
	ld hl,null
	cp 64
	jp nz,LevelInitUsingRasterFlip
	ld (DisablePaletteSwitcher_Plus2-2),hl
LevelInitUsingRasterFlip:
	call RasterColorsSetPalette1

;	ld a,1
;	ld bc,RasterColors_ColorArray1
;	ld de,RasterColors_ColorArray2
;	ld hl,RasterColors_ColorArray3
;	ld ix,RasterColors_ColorArray4
;	ld iy,null
;	call Akuyou_RasterColors_SetPointers



	ld hl,EventStreamArray		;Event Stream
	ld de,Event_SavedSettings	;Saved Settings
	call AkuYou_Event_StreamInit


	call Akuyou_Music_Restart

	ld hl,&2000		
	ld de,&1000
	call AkuYou_SpritePointerInit



	call Akuyou_ScreenBuffer_Init
	call Akuyou_RasterColors_Init




	;call RasterColors_Reset
LevelLoop:
	ifdef Debug
		call Timer_Start
	endif
	;halt
	call Akuyou_Background_Clear


	call Akuyou_EventStream_Process


	;halt
	call Akuyou_ObjectArray_Redraw


	;halt
	call Akuyou_Player_Handler



	call Akuyou_StarArray_Redraw


	call AkuYou_Player_StarArray_Redraw

	;halt
	call AkuYou_Player_DrawUI

	call Akuyou_PlaySfx

	ifdef Debug
		ld l,&0f
		call Timer_Stop


		call ShowLevelTime
	endif
	call Akuyou_ScreenBuffer_Flip
	jp LevelLoop

LevelShutdown:

ret
Timer_Start:
ld      hl,(&b8b4) ;this is the memloc KL_Time_Please actually uses!
;call &BD0D ;KL_TIME_PLEASE
ld a,l
ld (Timer_LastTime_Plus2-2),a
ld a,h
ld (Timer_LastTime_Plus2-1),a
ret

ShowLevelTime:
	ld hl,&C000
	call Akuyou_ShowSprite_SetBankAddr


	ld hl,&1001
	call Akuyou_DrawText_LocateSprite

	call Akuyou_GetLevelTime
	push bc	
	call ShowHex
	pop bc
	ld a,b
	call ShowHex
ret

Timer_Stop:
	ld hl,&C000
	call Akuyou_ShowSprite_SetBankAddr

;	ret
	ld h,&03
	ld l,&10
	call Akuyou_DrawText_LocateSprite ; set location
	;call &BD0D ;KL_TIME_PLEASE
	ld      hl,(&b8b4) ;this is the memloc KL_Time_Please actually uses!
	ld bc,&0000 :Timer_LastTime_Plus2
	;turn BC negative
	ld a,b
	cpl
	ld b,a
	ld a,c
	cpl
	ld c,a
	inc bc

	add hl,bc

	ld a,l
	call ShowHex
	ret

ShowHex:

	push af         ;store original byte value
	rrca            
	rrca
	rrca
	rrca
	call ShowHexDigit
	pop af          ;retrieve original byte value

ShowHexDigit:
;	and %00001111   ;isolate lower nibble. (This contains the digit value 0...15)
;	add a,"0"       ;add ASCII for 0. Digits 0...9 become "0"..."9", digits 10..15
;	cp "9"+1        
;	jr c,ShowHexDigitNum     ;if number is in digit range 0...9, display digit
;	add a,"A"-"9"-1 ;modify ASCII value so that digits in the range 10...15
and %00001111   ;isolate lower nibble. (This contains the digit value 0...15)
cp &a           ;Less than 10?  Set carry if so
sbc a,&69
daa             ;Because previous instruction was a subtract operation this
                ;is known as 'das' in x86
ShowHexDigitNum:
	jp Akuyou_DrawText_CharSprite   ;display digit



ClearBadguys:
	ld a,64
	ld (PaletteNo_Plus1-1),a	; turn off the alternate palette
	
	ld a,1
	ld i,a
	push hl
	call Akuyou_DoSmartBombCall
	pop hl
ret




RasterColorsStartPalleteFlip:
	push iy
		call AkuYou_Player_GetPlayerVars
		ld a,(iy-5)
		cp 64
	pop iy
	ret z

	xor a
 	ld (PaletteNo_Plus1-1),a
ret

RasterColorsSetPalette1:
	ld a,1
	ld bc,RasterColors_ColorArray1
	ld de,RasterColors_ColorArray2
	ld hl,RasterColors_ColorArray3
	ld ix,RasterColors_ColorArray4
	ld iy,PaletteSwitcher :DisablePaletteSwitcher_Plus2
jp Akuyou_RasterColors_SetPointers

PaletteSwitcher:
	ld a,64:PaletteNo_Plus1
	cpl	
	ld (PaletteNo_Plus1-1),a
	or a
	jp nz,RasterColorsSetPalette1
RasterColorsSetPalette2:
	ld a,1
	ld bc,RasterColors_ColorArray1Alt
	ld de,RasterColors_ColorArray2Alt
	ld hl,RasterColors_ColorArray3Alt
	ld ix,RasterColors_ColorArray4Alt
	ld iy,PaletteSwitcher
jp Akuyou_RasterColors_SetPointers




org &3ff0
jp LevelInit; - Level Start &3ff0
jp LevelLoop; - Level loop &3ff3
jp null     ; - Level resume &3ff6
jp null     ; - Level Shutdown &3ff9




limit &FFFF

save direct "T10-SC1.D01",&2000,&2000	;address,size...}[,exec_address]


