limit &FFFF
read "CoreDefs.asm" ; Remember! Put this first!
read "EventStreamDefinitions.asm"
limit &E00	
org &50


;
;Rastercolor buffer - 80 bytes (&50
RasterColors_ColorArray1:
	defb 1
	defb 1
	defb 64+20,64+24,64+29,64+11	 :IlluminatedPaletteA_Plus2
RasterColors_ColorArray2:
	defb 1
	defb 1

	defb 64+20,64+12,64+13,64+11	:IlluminatedPaletteB_Plus2
	defb 0
	defb 64+20,64+24,64+29,64+11
	defb 12
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+24,64+29,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
RasterColors_ColorArray3:
	defb 1
	defb 1
	defb 64+20,64+12,64+13,64+11 :IlluminatedPaletteC_Plus2
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
RasterColors_ColorArray4:
	defb 1
	defb 1 
	defb 64+20,64+31,64+14,64+11 :IlluminatedPaletteD_Plus2
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+31,64+14,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+31,64+14,64+11



align 256,&00
StarArraySize equ 255
StarArrayPointer: 	
defs StarArraySize*3,&00


ObjectArraySize equ 60
PlayerStarArraySize equ 36

align 256,&00
PlayerStarArrayPointer: 
defs 64,&00
ObjectArrayPointer:
defs 64,&00
align 256,&00
defs 255*5,&00

;defs ObjectArraySize*6,&00
;defs PlayerStarArraySize*3,&00

;align 256,&00

	

Event_SavedSettings:
defs 4*16,&00



CustomRam:
defs 64 ;  Pos-Tick-Pos-Tick ; enough memory for 16 enemies!

charChibiko: defw &0000
charNecromancer: defw &0000


limit &3FF0



org &2F00
MainSprites:
incbin "Sprites\Speech.spr"
;incbin "Sprites\LEVEL1A.SPR"
limit &3ff0
org &3590
align 256,&00
RasterColors_ColorArray1Alt:
	defb 1
	defb 1				
	defb &54,&55,&4C,&4B	


RasterColors_ColorArray2Alt:
	defb 2	; Switches
	defb 32	;delay			
	defb &54,&58,&5C,&4B	
	defb 64+16-32;delay			
	defb &54,&5D,&53,&4B



RasterColors_ColorArray3Alt:
	defb 2
	defb 48
	defb &54,&46,&5B,&4B
	defb 128
	defb &54,&46,&5a,&4B



RasterColors_ColorArray4Alt:
	defb 3 ; no of switches
	defb 0	;delays			
	defb &54,&46,&5A,&4B
	defb 255	;delays			
	defb &54,&4C,&4D,&4B
	defb 36	;delays			
	defb &54,&46,&5A,&4B



EventStreamArray:



defb 0,128+4,0,&24,0				; Static object
defb 0,%10010000+15,2				; Save Object settings to Bank 2


defb 0,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54	

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*2+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54		


defb 0,evtMultipleCommands+3
defb 	evtSettingsBank_Load+2
defb 	evtSingleSprite,TwoFrameSprite+5 ,24+160-16	,24+104
defb 	evtSaveLstObjToAdd
defw 		charNecromancer


defb 0,evtMultipleCommands+3
defb 	evtSettingsBank_Load+2
defb 	evtSingleSprite,TwoFrameSprite+2 ,24		,24+160
defb 	evtSaveLstObjToAdd
defw 		charChibiko

;Palette Change
defb 2,%01110000+4					; 4 Commands
	defb 240,0,6					; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40

	defb 240,26*0+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&44,&40	

	defb 240,26*1+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&44,&40		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40			




; Load Palette

	defb 4,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 200	;delay			
	defb &54,&5C,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&5C,&56,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B
	
	;defb 4	
	;defb 136				; Jump to a different level point
	;defw TestPos				; pointer
	;defb 180		

defb 10,evtCallAddress			;Call a memory location
defw	ShowText1Init


	defb 25
	defb 136				; Jump to a different level point
	defw SlowDownA				; pointer
	defb 20
SlowDownA:



; Load Palette

	defb 40,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 30	;delay			
	defb &54,&4C,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&5C,&56,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B
	
defb 40,evtCallAddress			;Call a memory location
defw	ShowText2Init

	defb 55
	defb 136				; Jump to a different level point
	defw SlowDownB				; pointer
	defb 50
SlowDownB:

defb 70,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 200	;delay			
	defb &54,&5C,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&5C,&56,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B
	
defb 70,evtCallAddress			;Call a memory location
defw	ShowText3Init


defb 97,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 10	;delay			
	defb &54,&52,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&5C,&56,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B
	

defb 97,evtCallAddress			;Call a memory location
defw	ShowText4Init



	defb 130,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 200	;delay			
	defb &54,&5C,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&5C,&56,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B

defb 130,evtCallAddress			;Call a memory location
defw	ShowText5Init

defb 160,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&4C,&4A,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0	;delay			
	defb &54,&4C,&4A,&4B

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&5C,&56,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B

defb 160,evtCallAddress			;Call a memory location
defw	ShowText6Init



	defb 190,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 200	;delay			
	defb &54,&5C,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 50
	defb &54,&5C,&56,&4B	

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B
TestPos:		
defb 190,evtCallAddress			;Call a memory location
defw	ShowText7Init

defb 210,evtCallAddress			;Call a memory location
defw	ShowText8Init





	defb 235,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &54,&58,&5F,&4B
	
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1	; Switches
	defb 0	;delay			
	defb &54,&58,&5F,&4B	

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 0
	defb &54,&58,&5F,&4B

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&58,&5F,&4B
	
defb 235,evtCallAddress			;Call a memory location
defw	ShowText0Init




defb 60,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&44,&40	

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&44,&40		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40			





defb 62,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54	

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*2+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54


defb 64,%10001001			;Call a memory location
	defw	EndLevel
EndLevel:
	pop hl	;
EndLevelFire:
	ld hl,	&0004 			
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return

ResetEventStream:
	push hl
		; wipe our memory, to clear out any junk from old levels
		ld de,StarArrayPointer+1
		ld hl,StarArrayPointer
		ld bc,&5FF
		ld (hl),0
		ldir

	pop hl
	;ld hl,EventStreamFadeOut	;Event Stream
	ld de,Event_SavedSettings	;Saved Settings
	call AkuYou_Event_StreamInit
	

ret

DiskMap_EndOutro_Screens  	equ &0DC1+&2800	;13 T13-SC1.D03
DiskMap_EndOutro_Screens_Size	equ 24	; &2000
DiskMap_EndOutro_Disk 		equ 2

OutroScreen1 equ &4000
OutroScreen2 equ &4003
OutroScreen3 equ &4006
OutroScreen4 equ &4009
OutroScreen5 equ &400C


LevelInit:

	;Load up the extra data - over the Bootstrap

	ld a,0
	ld hl,DiskMap_EndOutro_Screens
	ld b,DiskMap_EndOutro_Screens_Size
	ld c,DiskMap_EndOutro_Disk
	ld de,&4000
	call Akuyou_LoadDiscSector


	;call Keys_WaitForRelease


	ld hl,MainSprites
	ld de,&1000
	call AkuYou_SpritePointerInit



;	call Akuyou_Music_Restart

;	call Akuyou_ScreenBuffer_Reset


	ld a,3
	call Akuyou_BankSwitch_128k_SetCurrent
	ld a,&40
	call Akuyou_ScreenBuffer_Alt


	; force the cpc to show c0000
	ld hl,&0000
	ld a,&C0
	call &bd1f;mc_screen_offset

	call RasterColorsSetPalette1

 

	ld a,ObjectArraySize
	ld hl,ObjectArrayPointer
	call AkuYou_ObjectArray_Init

	ld hl,EventStreamArray		;Event Stream
	ld de,Event_SavedSettings	;Saved Settings
	call ResetEventStream

	call Akuyou_RasterColors_Init

	
call	Clear4000;call ShowText2

;	call WaitForFire

LevelLoop:


	call Akuyou_Timer_UpdateTimer
	halt
	call Akuyou_EventStream_Process
	halt
	call AkuYou_Player_ReadControls
		ld a, ixl	; read the keymap
		or %11110001
		cp 255
		jp nz,EndLevelFire
	halt
	call Akuyou_ObjectArray_Redraw

	call ShowBossText
	ld a,(BossCharNum_Plus1-1)
	ld b,a
	ld a,255
	sub b
	srl a
	srl a
	srl a
	srl a
	ld b,a
PauseLoopB:
	halt
	djnz PauseLoopB
;	call Akuyou_ScreenBuffer_Flip

	ld a,0 :ShowTextUpdate_Plus1
	or a
	jp z,LevelLoop
	cp 1
	jp z,ShowText1
	cp 2
	jp z,ShowText2
	cp 3
	jp z,ShowText3
	cp 4
	jp z,ShowText4
	cp 5
	jp z,ShowText5
	cp 6
	jp z,ShowText6
	cp 7
	jp z,ShowText7
	cp 8
	jp z,ShowText8
	cp 255
	jp z,ShowText0
	jp LevelLoop



Keys_WaitForRelease:
	call AkuYou_Player_ReadControls
	ld b,10
Keys_WaitForRelease_More:
	ld a,(hl)
	inc hl
	cp 255
	jp c,Keys_WaitForRelease
	djnz Keys_WaitForRelease_More
ret
WaitForFire:
	call PauseASec


WaitForFire_Continue:
	push bc
		call AkuYou_Player_ReadControls
	pop bc
	ld a, ixl	; read the keymap
	or %11110001
	cp 255
	jp z,WaitForFire_Continue
ret


PauseASec:
	push bc
	ld b,250
	ld c,4
PauseASecB:
		push bc
			call AkuYou_Player_ReadControls
		pop bc
		
	djnz PauseASecB
	dec c
	ld a,c
	or a
	jp nz,PauseASecB

	pop bc
ret


PauseASecForFire:
	push bc
	ld b,250
	ld c,4
PauseASecForFireB:
		push bc
			call AkuYou_Player_ReadControls
		pop bc
		ld a, ixl	; read the keymap
		or %11110001
		cp 255
		jp nz,PauseASecForFireDone
	djnz PauseASecForFireB
	dec c
	ld a,c
	or a
	jp nz,PauseASecForFireB

PauseASecForFireDone
	pop bc
ret


RasterColorsSetPalette1:
	ld a,1
	ld bc,RasterColors_ColorArray1
	ld de,RasterColors_ColorArray2
	ld hl,RasterColors_ColorArray3
	ld ix,RasterColors_ColorArray4
	ld iy,null;PaletteSwitcher
jp Akuyou_RasterColors_SetPointers

PaletteSwitcher:
	ld a,0:PaletteNo_Plus1
	cpl	
	ld (PaletteNo_Plus1-1),a
	or a
	jp nz,RasterColorsSetPalette1
RasterColorsSetPalette2:
	ld a,1
	ld bc,RasterColors_ColorArray1Alt
	ld de,RasterColors_ColorArray2Alt
	ld hl,RasterColors_ColorArray3Alt
	ld ix,RasterColors_ColorArray4Alt
	ld iy,PaletteSwitcher
jp Akuyou_RasterColors_SetPointers
ShowText1Init:
		ld a,1
UpdateShowText:
		ld(ShowTextUpdate_Plus1-1),a
		ret
ShowText2Init:
		ld a,2
		jr UpdateShowText
ShowText3Init:
		ld a,3
		jr UpdateShowText
ShowText4Init:
		ld a,4
		jr UpdateShowText
ShowText5Init:
		ld a,5
		jr UpdateShowText
ShowText6Init:
		ld a,6
		jr UpdateShowText
ShowText7Init:
		ld a,7
		jr UpdateShowText
ShowText8Init:
		ld a,8
		jr UpdateShowText
ShowText0Init:
		ld a,255
		jr UpdateShowText
NoSpeech:
	ld a,5	:NecromancerNospeech_Plus1
	ld hl,(charNecromancer)
	call SetSprite

	ld a,2	:ChibikoNospeech_Plus1
	ld hl,(charChibiko)
	jp SetSprite


ShowText2:


		ld a,5+TwoFrameSprite
		ld hl,(charNecromancer)
		call SetSprite

		ld a,2
		ld hl,(charChibiko)
		call SetSprite

		ld hl,Subtitles2
		ld(OnscreenTextPointer_Plus2-2),hl
	
		ld hl,OutroScreen2
		ld (CompiledScreen_Plus2-2),hl
	
		ld a,&10-3
		ld (OnscreenTextPos_Plus1-1),a
		jp ResetText
ShowText3:

		ld a,5
		ld hl,(charNecromancer)
		call SetSprite

		ld a,3+TwoFrameSprite
		ld hl,(charChibiko)
		call SetSprite

		ld hl,OutroScreen1
		ld (CompiledScreen_Plus2-2),hl

		ld hl,Subtitles3
		ld(OnscreenTextPointer_Plus2-2),hl
	
	
		ld a,&14
		ld (OnscreenTextPos_Plus1-1),a
		jp ResetText
		

ShowText4:
	
		ld a,5+TwoFrameSprite
		ld hl,(charNecromancer)
		call SetSprite

		ld a,2
		ld hl,(charChibiko)
		call SetSprite

		ld hl,OutroScreen3
		ld (CompiledScreen_Plus2-2),hl

		ld hl,Subtitles4
		ld(OnscreenTextPointer_Plus2-2),hl
	
	
		ld a,&10-3
		ld (OnscreenTextPos_Plus1-1),a
		jp ResetText
ShowText5:

		ld a,5
		ld hl,(charNecromancer)
		call SetSprite

		ld a,3+TwoFrameSprite
		ld hl,(charChibiko)
		call SetSprite


		ld hl,OutroScreen1
		ld (CompiledScreen_Plus2-2),hl


		ld hl,Subtitles5
		ld(OnscreenTextPointer_Plus2-2),hl

		ld hl,OutroScreen1
		ld (CompiledScreen_Plus2-2),hl
	
		ld a,&14
		ld (OnscreenTextPos_Plus1-1),a
		jp ResetText
		

ShowText6:
	
		ld a,5+TwoFrameSprite
		ld hl,(charNecromancer)
		call SetSprite

		ld a,2
		ld hl,(charChibiko)
		call SetSprite


		ld hl,OutroScreen4
		ld (CompiledScreen_Plus2-2),hl


		ld hl,Subtitles6
		ld(OnscreenTextPointer_Plus2-2),hl
	
	
		ld a,&10-3
		ld (OnscreenTextPos_Plus1-1),a
		jp ResetText
ShowText7:

		ld a,5
		ld hl,(charNecromancer)
		call SetSprite
		LD A,4
		ld (ChibikoNospeech_Plus1-1),a
		ld a,3+TwoFrameSprite
		ld hl,(charChibiko)
		call SetSprite

		ld hl,OutroScreen1
		ld (CompiledScreen_Plus2-2),hl

		ld hl,Subtitles7
		ld(OnscreenTextPointer_Plus2-2),hl
	
	
		ld a,&14
		ld (OnscreenTextPos_Plus1-1),a
		jp ResetText
ShowText8:

		ld a,5
		ld hl,(charNecromancer)
		call SetSprite
		LD A,4
		ld (ChibikoNospeech_Plus1-1),a
		ld a,3+TwoFrameSprite
		ld hl,(charChibiko)
		call SetSprite

		ld hl,OutroScreen1
		ld (CompiledScreen_Plus2-2),hl

		ld hl,Subtitles8
		ld(OnscreenTextPointer_Plus2-2),hl
	
	
		ld a,&14
		ld (OnscreenTextPos_Plus1-1),a
		jp ResetText
ShowText0:

		ld a,6
		ld hl,(charNecromancer)
		call SetSprite
		LD A,6
		ld (ChibikoNospeech_Plus1-1),a
		ld (NecromancerNospeech_Plus1-1),a
		ld a,6
		ld hl,(charChibiko)
		call SetSprite

		ld hl,OutroScreen5
		ld (CompiledScreen_Plus2-2),hl

		ld hl,Subtitles0
		ld(OnscreenTextPointer_Plus2-2),hl
	
	
		ld a,&10-3
		ld (OnscreenTextPos_Plus1-1),a
		jp ResetText

ShowText1:
		ld hl,Subtitles1
ShowTextChibiko:
		
		ld(OnscreenTextPointer_Plus2-2),hl
		ld a,2+TwoFrameSprite
		ld hl,(charChibiko)
		call SetSprite

	
		;pop hl
		ld a,5
		ld hl,(charNecromancer)
		call SetSprite

	
		ld a,&14
		ld (OnscreenTextPos_Plus1-1),a


ResetText:
		ld a,1
		ld (BossCharNum_Plus1-1),a
		ld a,0
		ld(ShowTextUpdate_Plus1-1),a
		ld a,15
		ld (OnscreenTimer_Plus1-1),a
		call Clear4000
		jp levelloop
	

SubtitlesEmpty: 
db  4," "," "+&80
db &0

Subtitles1: 
db  4,"Yeah! Not so mouthy now are you!!","!"+&80
db  4,"Now, Who the fuck are you","?"+&80
db  4,"Why are you creating these"," "+&80
db  4,"monsters and invading my land??","?"+&80
db &0


Subtitles2: 
db  1,"I USED to be the Village elder",","+&80 
db  1,"but since you raised the villag","e"+&80
db  1,"and killed all the villager","s"+&80
db  1,"I fled and hid in this cave!","!"+&80
db &0


Subtitles3: 
db  4,"er..","."+&80
db  4,"well..","."+&80
db  4,"Yes, I did SORT-OF do THAT",","+&80
db  4,"But what about these monsters?","?"+&80
db &0

Subtitles4: 
db  1,"Huh, Monsters? These are th","e"+&80
db  1,"animals that lived in the forest",","+&80
db  1,"The river got polluted, and the","y"+&80
db  1,"got ill and mutated","."+&80
db &0


Subtitles5: 
db  4,"um..","."+&80
db  4,"that was supposed to be a jok","e"+&80
db  4,"hmm... But",","+&80
db  4,"But why are you sending them to me?","?"+&80
db &0

Subtitles6: 

db  1,"I'm not doing that! Fire destroye","d"+&80
db  1,"their habitat,so now the","y"+&80
db  1,"are migrating to better lan","d"+&80
db  1,"like the mountains.","."+&80
db &0



Subtitles7: 
db  4,"ah...  Er... Um.. ahem!"," "+&80
db  4,"Well... ah, this is akward        "," "+&80
db &0
Subtitles8: 
db  4,"I suppose I COULD cut down an","d"+&80
db  4,"ONLY commit massacres ever","y"+&80
db  4,"other tuesday!!","!"+&80

db &0
;      .1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0
;      .9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0

Subtitles0: 
;b  4,"1234567890123456789012345678901234567890
db  14,"Game Over!!","!"+&80
db  10,"        "," "+&80
db  10," "," "+&80
db  4,"I hope you enjoyed playing this"," "+&80
db  4,"game as much as I did making it","!"+&80
db  10," "," "+&80
db  6,"See you again next time in",":"+&80
db  14,"CHIBI AKUMA","s"+&80
db  7,"Episode 2: Confrontation","!"+&80
db  10," "," "+&80
db  10,"Thanks For Playing!!","!"+&80
db  3,"Don't forget to turn off your set","!"+&80
db &0
ShowBossText:
	ld a,15 :OnscreenTimer_Plus1
	cp 10
	ret c
	ld bc,SubtitlesEmpty :OnscreenTextPointer_Plus2
ShowBossText_StartText:
	;ld hl,&C000
	;call Akuyou_ShowSprite_SetBankAddr
	call Akuyou_SpriteBank_Font
	ld l,&14 :OnscreenTextPos_Plus1
	ld a,1:BossCharNum_Plus1
	ld i,a	; show up to 255 chars
	
ShowBossText_MoreText:
	ei
	halt
	ld a,(bc)

	or a
	jp z,ShowBossText_AllOnscreen ; See if we have reached the end of the string

	ld h,a
	inc bc

	push hl
		call Akuyou_DrawText_LocateSprite

		call Akuyou_DrawText_PrintString
	pop hl
	;inc l
	;inc l
	inc l
	ld a,i
	dec a
	inc bc
	jp nz,ShowBossText_MoreText

	ld a,(bc)
	or a
	jp z,ShowBossText_AllOnscreen ; See if we have reached the end of the string
	ld a,(BossCharNum_Plus1-1)
	inc a
	nop
	nop :ShowTextSpeedup_Plus1
ShowBossTextNoSpeedup:
	ld (BossCharNum_Plus1-1),a

ret
ShowBossText_AllOnscreen:
	jp NoSpeech

	;ld a,(OnscreenTimer_Plus1-1)
	;dec a
	;ld (OnscreenTimer_Plus1-1),a

	;cp 10
	;ret nz
	;ld a,0;9; only one page of text
	;ld (OnscreenTimer_Plus1-1),a
;	ld a,BossText2End-BossText2-20
	;ld a,1
	;ld (BossCharNum_Plus1-1),a

ret

SetSprite:; YYYYYXXXXMMMMSSSLLLLPPP
	ld i,a
	ld a,h
	cp &69
	ret z		;not on screen yet


;	ld d,0
;	ld e,objectarraysize
	;y
	inc h;add hl,de 	
	;x
	inc h;	add hl,de 	
	;move
	inc h;	add hl,de 	
	ld a,i
	ld (hl),a
	inc h;	add hl,de 	;spr
	inc h;	add hl,de 	;Life

	;program
ret

Clear4000:
	di
	ld hl,&7FFF
	ld b,256
	ld de,&0000
	call SpFill
	ei
	ld a,0
	call Akuyou_BankSwitch_128k
	call OutroScreen1 :CompiledScreen_Plus2;call CompiledScreen1
	jp Akuyou_BankSwitch_128k_Reset
;ret



SpFill:
ld (SpRestoreFill_Plus2-2),sp

SpFillContinue:
ld sp,hl
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
push de
ld hl,&0000
add hl,sp
ld sp,&0000:SpRestoreFill_Plus2
ei
di
djnz SpFillContinue
ei
null:ret



limit &3FFF
org &3ff0
jp LevelInit; - Level Start &3ff0
jp LevelLoop; - Level loop &3ff3
jp null     ; - Level resume &3ff6
jp null     ; - Level Shutdown &3ff9





save direct "T50-SC1.D02",&2F00,&1100	;address,size...}[,exec_address]


